<?php
/**
 * Plugin CIBC
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

function cibc_banniere($flux='',$lien=false){
	static $done = false;
	
	// eviter une double insertion
	if ($done)
		return $flux;
	else
		$done = true;

	
	// configuration de la banniere
	$cibc_meta = cibc_tableau_meta();
	$url_savoir = "";
	$url_refus = "";
	if ($cibc_meta['url_savoir'])
            $url_savoir = parametre_url($cibc_meta['url_savoir'],"lang",$GLOBALS['spip_lang'],'&');

	if ($cibc_meta['url_refus'])
            $url_refus = parametre_url($cibc_meta['url_refus'],"lang",$GLOBALS['spip_lang'],'&');

	$comportement_desactiver = $cibc_meta['comportement_desactiver'];
	$duree_cookie = intval($cibc_meta['duree_cookie'])*24*3600*1000; // passer de jours en millisecondes

	
	// contenu de la banniere (texte, boutons)
	$bouton_refus = _T('cibc:bouton_refus');
	$bouton_accepte = _T('cibc:bouton_accepte');
	$bouton_savoir = _T('cibc:bouton_savoir');
	$bouton_fermer = _T('cibc:bouton_fermer');
	$div_debut_boutons = rawurlencode('<div class="cicb_boutons">');
	$div_fin_boutons = rawurlencode('</div>');
	$fermer = rawurlencode('<button type="button" class="cicb_fermer" onclick="cibcRemoveMe();"><span>X</span></button>');
	$texte = $fermer;	
	$texte .= rawurlencode(cibc_texte_script(propre('<div class="cicb_texte">'.cibc_to_utf8($cibc_meta['texte']).'</div>')));
	$texte .= $div_debut_boutons;
	if ($cibc_meta['bouton_savoir']=='oui')
		$texte .= rawurlencode('<a class="bouton savoir" href="'.$url_savoir.'">'.$bouton_savoir.'</a>');
	if ($cibc_meta['bouton_accepte']=='oui')
		$texte .= rawurlencode('<button type="button" class="bouton accepte" onclick="javascript:cibcAccepte()">'.$bouton_accepte.'</button>');		
	if ($cibc_meta['bouton_refus']=='oui')
		$texte .= rawurlencode('<button type="button" class="bouton refus" onclick="javascript:cibcRefuse()">'.$bouton_refus.'</button>');
	$texte .= $div_fin_boutons;


	// comportement de la desactivation des cookies
	$debut_xiti = 'var cibcXiti = "";';
	$debut_ga = 'var cibcIdga = "";';
	$param_GA_XITI = '';
	$cibcOptOutExterne = '';
    $si_comportement_desactiver = '';
    
	// si la page [En savoir plus] ou [Refuser] indique a l'utilisateur comment desactiver les cookies
	if ($comportement_desactiver=='libre'){
	
		$debut_xiti = 'var cibcXiti=cibcGetCookie("cibcOptOutXITI");var paramUrlXiti=cibcGetUrlParam("cibcOptOutXITI");if(paramUrlXiti){if(paramUrlXiti=="oui"||paramUrlXiti=="non"){cibcXiti=paramUrlXiti;cibcSetCookie("cibcOptOutXITI",paramUrlXiti)}}';

		$debut_ga = 'var cibcIdga=cibcGetCookie("cibcOptOutGA");var paramUrlIdga=cibcGetUrlParam("cibcIDGA");if(paramUrlIdga){if(paramUrlIdga=="non"){cibcIdga=paramUrlIdga;cibcSetCookie("cibcOptOutGA",paramUrlIdga)}else{testidga=paramUrlIdga.replace("ua-","");testidga=testidga.replace("UA-","");testidga=testidga.replace("-","");if(isNaN(testidga)===false){cibcIdga=paramUrlIdga;cibcSetCookie("cibcOptOutGA",paramUrlIdga)}}}if(cibcIdga && cibcIdga!="non"){var gaProperty=cibcIdga;var disableStr="ga-disable-"+gaProperty;window[disableStr]=true}';
	
		$param_GA_XITI = 'cibcParams[1]="GA";cibcParams[2]="XITI";cibcCookies[1]=cibcGetCookie("cibcOptOutGA");cibcCookies[2]=cibcGetCookie("cibcOptOutXITI");';		

		$cibcOptOutExterne = 'cibcOptOutExterne();';

	} elseif ($comportement_desactiver=='avant'){
		
		// si desactiver la pose de cookies tiers dans l'attente de l'acceptation
		// alors si pas encore de consentement ou si refus, optout est egal a "oui"
	    $si_comportement_desactiver = 'if (cibcGetCookieConsent()!="oui") {return "oui";} else {return "non";}';
	} elseif ($comportement_desactiver=='apres'){

		// si desactiver la pose de cookies tiers lors du refus explicite
		// alors si refus, optout est egal a "oui"
	    $si_comportement_desactiver = 'if (cibcGetCookieConsent()=="non"){return "oui";} else {return "non";}';
	}
	
	
	// comportement du bouton refuser
	if ($url_refus)
		$redirige_ou_ferme = 'document.location.href="'.$url_refus.'"';
	else
	    $redirige_ou_ferme = 'var element = document.getElementById("banniere-cookie"); element.parentNode.removeChild(element);';


	// comportement de la banniere
    $test_poursuite_navigation = '1==1';
	
	if ($cibc_meta['comportement']=='2'){
		$test_poursuite_navigation = '1==2';
	} else {
//		$test_poursuite_navigation = 'document.referrer && document.referrer.split("/")[2] == document.location.hostname';
		$test_poursuite_navigation = 'document.referrer && (document.referrer.split("/")[2] == document.location.hostname) && cibcGetCookie("cibcInit")';
		if ($url_savoir){
		    $test_poursuite_navigation .= ' && document.location.href != cibcHref() + decodeURIComponent("'.rawurlencode($url_savoir).'") && document.referrer != cibcHref() + decodeURIComponent("'.rawurlencode($url_savoir).'")';
		}
	}	
	
	$banniere_timeout = '';
	if ($cibc_meta['comportement']=='3')
		$banniere_timeout = 'var cibcTimerID=setTimeout(function(){cibcRemoveMe();}, 10000);';	
	
	$banniere_si_authentifie = 2;
	if (isset($cibc_meta['banniere_si_authentifie']) AND $cibc_meta['banniere_si_authentifie']=='oui')
		$banniere_si_authentifie = 3;


	// page savoir plus ou refuser
	$test_page_savoir_ou_refuser = '1==2';
	if ($url_savoir){
		$test_page_savoir_ou_refuser .= ' || document.getElementById("cibcSavoirPlus")!=null ';
	    $test_page_savoir_ou_refuser .= ' || cibcHrefSansParam() == cibcHref() + decodeURIComponent("'.rawurlencode($url_savoir).'")';
	}
	if ($url_refus)
	    $test_page_savoir_ou_refuser .= ' || cibcHrefSansParam() == cibcHref() + decodeURIComponent("'.rawurlencode($url_refus).'")';


	// style de la banniere
	if (!$lien AND $f = find_in_path($cibc_meta['css']))
		$flux .= '
<link rel="stylesheet" href="'.$f.'" type="text/css" media="all" />
';


// le script (sans aucun retour a la ligne afin que les pages HTML restent lisibles)
$script = $debut_xiti.$debut_ga.' function cibcPath(){var cipath=window.location.pathname;cipath=cipath.substring(0,cipath.lastIndexOf("/"));if(cipath===-1)cipath="/";else cipath=cipath+"/";return cipath}function cibcHref(){return window.location.protocol+"//"+window.location.host+cibcPath()}function cibcHrefSansParam() {var cihref = document.location.href; var n = cihref.indexOf("&cibcOptOut"); if (n > 1){cihref = cihref.substring(0,n);} n = cihref.indexOf("&cibcIDGA"); if (n > 1){cihref = cihref.substring(0,n);} return cihref;}function cibcGetExpireDate(){var cookieTimeout='.$duree_cookie.';var date=new Date();date.setTime(date.getTime()+cookieTimeout);var expires="expires="+date.toGMTString();return expires}function cibcSetCookie(nom,valeur){document.cookie=nom+"="+valeur+";"+cibcGetExpireDate()+"; path="+cibcPath()}function cibcSetCookieConsentOui(){document.cookie="cibcConsent=oui;"+cibcGetExpireDate()+" ; path="+cibcPath()}function cibcSetCookieConsentNon(){document.cookie="cibcConsent=non;"+cibcGetExpireDate()+" ; path="+cibcPath()}function cibcGetCookie(NomDuCookie){if(document.cookie.length>0){begin=document.cookie.indexOf(NomDuCookie+"=");if(begin!=-1){begin+=NomDuCookie.length+1;end=document.cookie.indexOf(";",begin);if(end==-1)end=document.cookie.length;return unescape(document.cookie.substring(begin,end))}}return ""}function cibcGetCookieConsent(){consentCookie=cibcGetCookie("cibcConsent");if(!consentCookie){if('.$test_poursuite_navigation.'){cibcSetCookieConsentOui();consentCookie="oui"}}return consentCookie}function cibcGetUrlParam(name){name=name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");var regex=new RegExp("[\\?&]"+name+"=([^&#]*)");var results=regex.exec(window.location.search);if(results==null)return "";else return results[1]}function cibcFade(element){var op=1;var ua=navigator.userAgent.toLowerCase();var isIE=false;if(ua.indexOf("msie")!=-1){isIE=true}var timer=setInterval(function(){if(op<=0.1){clearInterval(timer);element.parentNode.removeChild(element)}else{element.style.opacity=op;if(isIE===true){element.style.filter="alpha(opacity="+op*100+")"}op-=op*0.1}},50)}function cibcDemander(){if(cibcGetCookie("spip_admin")&&'.$banniere_si_authentifie.'==2){cibcSetCookieConsentOui()}else{var bodytag=document.getElementsByTagName("body")[0];var div=document.createElement("div");div.setAttribute("id","banniere-cookie");div.innerHTML=decodeURIComponent("'.$texte.'");bodytag.insertBefore(div,bodytag.firstChild);cibcSetCookie("cibcInit","oui");'.$banniere_timeout.'}}function cibcRefuse(){cibcSetCookieConsentNon();'.$redirige_ou_ferme.'}function cibcAccepte(){cibcSetCookieConsentOui();var element=document.getElementById("banniere-cookie");element.parentNode.removeChild(element)}function cibcRemoveMe(){cibcSetCookieConsentOui();var element=document.getElementById("banniere-cookie");cibcFade(element)}function cibcRetour(){divRetour = document.getElementById("cibcRetour");if(divRetour!=null){if(divRetour.firstChild.className=="cibcRetour"){divRetour.firstChild.href = document.referrer;}}}function cibcOptOutExterne(){if('.$test_page_savoir_ou_refuser.'){var cibcLiens=document.getElementsByTagName("a");for(var i=0;i<cibcLiens.length;i++){if(cibcLiens[i].className.substring(0,10)=="cibcOptOut"){cibcLiens[i].id="cibc"+i;cibcLiens[i].setAttribute("onclick","cibcCreerImg(this.id); return false;");cibcTableauOptOutExterne["cibc"+i]=cibcLiens[i].href;cibcLiens[i].href=""}}}}function cibcCreerImg(i){if(cibcTableauOptOutExterne[i]!==undefined&&cibcTableauOptOutExterne[i]){var element=document.getElementById(i);var img=document.createElement("img");img.setAttribute("src",cibcTableauOptOutExterne[i]);element.insertBefore(img,element.firstChild);cibcTableauOptOutExterne[i]=""}return false}function cibcAfficheLien(valeur_param,valeur_cookie){if('.$test_page_savoir_ou_refuser.'){divOptout=document.getElementById("cibcOptOut"+valeur_param);if(divOptout!=null){divOptout.firstChild.className="spip_in";if(valeur_cookie&&valeur_cookie!="non"){divOptout.style.display="none"}else{divOptout.style.display="inline"}}divOptin=document.getElementById("cibcOptIn"+valeur_param);if(divOptin!=null){divOptin.firstChild.className="spip_in";if(valeur_cookie&&valeur_cookie!="non"){divOptin.style.display="inline"}else{divOptin.style.display="none"}}}}function cibcOptOut(){'.$si_comportement_desactiver.'consentCookie=cibcGetCookieConsent();if(consentCookie=="oui")return"non";else if(consentCookie=="non")return"oui";else return ""}function cibcOptOutXITI(){'.$si_comportement_desactiver.'return cibcXiti}function cibcOptOutGA(){'.$si_comportement_desactiver.'return cibcIdga}function cibcLoad(){var consentCookie=cibcGetCookieConsent();var cibcParams=[];var cibcCookies=[];cibcParams[0]="CIBC";cibcCookies[0]="";'.$param_GA_XITI.''.$cibcOptOutExterne.'cibcRetour();var paramUrl=cibcGetUrlParam("cibcOptOut");if(paramUrl=="oui"){cibcSetCookieConsentNon();consentCookie="non";for(var i=1;i<cibcCookies.length;i++){if(cibcCookies[i]){cibcSetCookie("cibcOptOut"+cibcParams[i],"oui")};cibcCookies[i]="oui";}}if(paramUrl=="non"){cibcSetCookieConsentOui();consentCookie="oui";for(var i=1;i<cibcCookies.length;i++){if(cibcCookies[i]){cibcSetCookie("cibcOptOut"+cibcParams[i],"non")};cibcCookies[i]="non";}}if(!consentCookie){if('.$test_poursuite_navigation.'){cibcSetCookieConsentOui();consentCookie="oui"}else{cibcDemander()}}var divOptout="";var divOptin="";if(consentCookie=="oui")cibcCookies[0]="non";else if(consentCookie=="non")cibcCookies[0]="oui";for(var i=0;i<cibcParams.length;i++){cibcAfficheLien(cibcParams[i],cibcCookies[i]);}}var cibcTableauOptOutExterne=[];if(window.jQuery){jQuery(document).ready(function($){cibcLoad()})}else{window.onload=function(){cibcLoad()}}';
	if (!$lien)
		$script ='<script type="text/javascript">'
                . '<!-- 
                '.$script.'
                 -->
                </script>';
	
	$flux .= $script;
	
	return $flux;
}

function cibc_css(){
	$return = '';
	
	// configuration de la banniere
	$cibc_meta = cibc_tableau_meta();
	if ($f = find_in_path($cibc_meta['css']))
		$return = $f;

	return $return;
}

function cibc_tableau_meta() {	
	$return = array();
		
	if (isset($GLOBALS['meta']['cibc'])) {
		$meta_cibc = @unserialize($GLOBALS['meta']['cibc']);
		
		if (is_array($meta_cibc))
			$return = $meta_cibc;
	}

	if (!$return){		
		// valeurs par defaut
		include_spip('inc/charsets');
	
		$texte = "En poursuivant votre navigation sur ce site, vous acceptez l'utilisation de cookies pour réaliser des statistiques de visites.";
			
		$return = array(
			'texte' => transcoder_page($texte),
			'url_savoir' => '',
			'url_refus' => '',
			'duree_cookie' => 395,
			'css' => '_css/cibc_en_bas_fond_noir.css',
			'bouton_savoir' => 'oui',
			'bouton_accepte' => 'oui',
			'bouton_refus' => 'oui',
			'comportement_desactiver' => 'libre',
			'banniere_si_authentifie' => 'oui',
			'comportement' => '1'	
		);
	}

	// parametrage par constantes (prioritaire)
	foreach ($return AS $cle=>$valeur){
		$constante = cibc_constantes($cle);
		if ($constante!==NULL){
			$return[$cle] = $constante;
		}
	}

    return $return;
}

// parametrage par constantes
function cibc_constantes($nom) {
	$return = NULL;

	switch($nom) {

	case 'texte':
		if (defined("_CIBC_TEXTE") AND _CIBC_TEXTE){
			include_spip('inc/charsets');
			$return = transcoder_page(_CIBC_TEXTE);
		}
		break;

	case 'url_savoir':
		if (defined("_CIBC_URL_SAVOIR") AND _CIBC_URL_SAVOIR)
			$return = _CIBC_URL_SAVOIR;
		break;

	case 'url_refus':
		if (defined("_CIBC_URL_REFUS") AND _CIBC_URL_REFUS)
			$return = _CIBC_URL_REFUS;
		break;

	case 'duree_cookie':
		if (defined("_CIBC_DUREE_COOKIE") AND intval(_CIBC_DUREE_COOKIE)>0 AND intval(_CIBC_DUREE_COOKIE)<=395)
			$return = intval(_CIBC_DUREE_COOKIE);
		break;

	case 'css':
		if (defined("_CIBC_CSS") AND _CIBC_CSS){
			if (substr(_CIBC_CSS, 0, 10)=='_css/cibc_'){
				$return = _CIBC_CSS;
			}
		}
		break;

	case 'bouton_savoir':
		if (defined("_CIBC_BOUTON_SAVOIR") AND in_array(_CIBC_BOUTON_SAVOIR, array('oui','non')))
			$return = _CIBC_BOUTON_SAVOIR;		
		break;

	case 'bouton_accepte':
		if (defined("_CIBC_BOUTON_ACCEPTE") AND in_array(_CIBC_BOUTON_ACCEPTE, array('oui','non')))
			$return = _CIBC_BOUTON_ACCEPTE;		
		break;

	case 'bouton_refus':
		if (defined("_CIBC_BOUTON_REFUS") AND in_array(_CIBC_BOUTON_REFUS, array('oui','non')))
			$return = _CIBC_BOUTON_REFUS;		
		break;

	case 'banniere_si_authentifie':
		if (defined("_CIBC_BANNIERE_SI_AUTHENTIFIE") AND in_array(_CIBC_BANNIERE_SI_AUTHENTIFIE, array('oui','non')))
			$return = _CIBC_BANNIERE_SI_AUTHENTIFIE;
		break;

	case 'comportement_desactiver':
		if (defined("_CIBC_COMPORTEMENT_DESACTIVER") AND in_array(_CIBC_COMPORTEMENT_DESACTIVER, array('avant','apres','libre')))
			$return = _CIBC_COMPORTEMENT_DESACTIVER;		
		break;
		
	case 'comportement':
		if (defined("_CIBC_COMPORTEMENT") AND in_array(_CIBC_COMPORTEMENT, array('1','2','3')))
			$return = _CIBC_COMPORTEMENT;		
		break;

	}	

	return $return;
}


function cibc_to_utf8($texte){
	if ($GLOBALS['meta']['charset'] != 'utf-8'){
		include_spip('inc/charsets');
		$texte = unicode2charset(charset2unicode($texte), 'utf-8');
	}

	return $texte;
}

function cibc_texte_script($texte) {
	$texte = str_replace("'",'"',$texte);
	return str_replace('\'', '\\\'', str_replace('\\', '\\\\', $texte));
}


?>