<?php
/**
 * Plugin CIBLOC
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) return;


function cibloc_blocs_par_defaut() {

return array(

// Le type bloc    

'bloc_bordure'=>array(
'id'=>'bordure',
'type'=>'bloc',
'nom'=>'Bloc avec une bordure',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'padding_bottom'=>'1.0',
'rang'=>10,
'preremplir'=>'{{{Intertitre}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_ombre'=>array(
'id'=>'ombre',
'type'=>'bloc',
'nom'=>'Bloc avec une ombre',
'bordure'=>'ombre',
'couleur_bordure'=>'gris5',
'padding_bottom'=>'1.0',
'rang'=>20,
'preremplir'=>'{{{Intertitre}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_centre'=>array(
'id'=>'centre',
'type'=>'bloc',
'nom'=>'Bloc avec le texte centré',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'alignement'=>'center',
'padding_top'=>'0.65',
'padding_bottom'=>'0.65',
'padding_right'=>'1.5',
'padding_left'=>'1.5',
'rang'=>30,
'preremplir'=>'{{{Intertitre}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_gris'=>array(
'id'=>'gris',
'type'=>'bloc',
'nom'=>'Bloc gris avec une bordure',
'couleur'=>'gris1',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'padding_top'=>'0.5',
'padding_bottom'=>'0.5',
'rang'=>40,
'preremplir'=>'{{{Intertitre}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_blanc'=>array(
'id'=>'blanc',
'type'=>'bloc',
'nom'=>'Bloc blanc',
'couleur'=>'blanc',
'rang'=>50,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_defaut'=>array(
'id'=>'defaut',
'type'=>'bloc',
'nom'=>'Bloc avec la couleur par défaut',
'couleur'=>'gris2',
'rang'=>60,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_gris2'=>array(
'id'=>'gris2',
'type'=>'bloc',
'nom'=>'Bloc gris 2',
'couleur'=>'gris2',
'rang'=>70,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_noir'=>array(
'id'=>'noir',
'type'=>'bloc',
'nom'=>'Bloc noir',
'couleur'=>'noir2',
'rang'=>80,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_couleur1'=>array(
'id'=>'couleur1',
'type'=>'bloc',
'nom'=>'Bloc couleur 1',
'couleur'=>'couleur1',
'rang'=>90,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_couleur2'=>array(
'id'=>'couleur2',
'type'=>'bloc',
'nom'=>'Bloc couleur 2',
'couleur'=>'couleur2',
'rang'=>100,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_couleur3'=>array(
'id'=>'couleur3',
'type'=>'bloc',
'nom'=>'Bloc couleur 3',
'couleur'=>'couleur3',
'rang'=>110,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.'
),

'bloc_bouton'=>array(
'id'=>'bouton',
'type'=>'bloc',
'nom'=>'Bloc bouton',
'couleur'=>'gris1',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'alignement'=>'center',
'rang'=>120,
'preremplir'=>'{{{Intertitre}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus.
[bouton_gris][Exemple de lien->http://www.google.fr][/bouton_gris]'
),

'bloc_accordeon'=>array(
'id'=>'accordeon',
'type'=>'bloc',
'nom'=>'Bloc accordéon dépliable (avec un seul item déplié à la fois)',
'couleur'=>'gris5',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'couleur_bouton'=>'gris5',    
'rang'=>130,
'code_html_ouvrant'=>'<div class="cibloc_accordeon_commun">',
'code_html_fermant'=>'</div>',
'preremplir'=>'{{{Question}}}
réponse
{{{Question}}}
réponse
{{{Question}}}
réponse'
),

'bloc_accordeon2'=>array(
'id'=>'accordeon2',
'type'=>'bloc',
'nom'=>'Bloc accordéon dépliable',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'couleur_bouton'=>'gris5',    
'rang'=>140,
'code_html_ouvrant'=>'<div class="cibloc_accordeon_commun">',
'code_html_fermant'=>'</div>',
'preremplir'=>'{{{Question}}}
réponse
{{{Question}}}
réponse
{{{Question}}}
réponse'
),

'bloc_accordeon3'=>array(
'id'=>'accordeon3',
'type'=>'bloc',
'nom'=>'Bloc accordéon toujours déplié (non pliable)',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'couleur_bouton'=>'gris5',    
'rang'=>150,
'code_html_ouvrant'=>'<div class="cibloc_accordeon_commun">',
'code_html_fermant'=>'</div>',
'preremplir'=>'{{{Question}}}
réponse
{{{Question}}}
réponse
{{{Question}}}
réponse'
),

'bloc_imagebas'=>array(
'id'=>'imagebas',
'type'=>'bloc',
'nom'=>'Bloc avec le texte en bas sur l\'image',
'couleur'=>'blanc',
'couleur_survol'=>'gris4',
'padding_top'=>'0',
'padding_bottom'=>'0',
'padding_right'=>'0',
'padding_left'=>'0',    
'rang'=>160,
'preremplir'=>'<demoimage|nom=image2_large>
[texte_bas]
[Exemple de lien->http://www.google.fr]
[/texte_bas]'
),

'bloc_image'=>array(
'id'=>'image',
'type'=>'bloc',
'nom'=>'Bloc avec le texte sur l\'image',
'couleur'=>'blanc',
'couleur_survol'=>'gris4',
'alignement'=>'center',
'padding_top'=>'0',
'padding_bottom'=>'0',
'padding_right'=>'0',
'padding_left'=>'0',    
'rang'=>170,
'preremplir'=>'<demoimage|nom=image3_large>
[texte_dessus]
{{{Intertitre}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius.
[bouton_blancvide][Exemple de lien->http://www.google.fr][/bouton_blancvide]
[/texte_dessus]'
),

'bloc_trait'=>array(
'id'=>'trait',
'type'=>'bloc',
'nom'=>'Trait de séparation (remplacé par texte_trait)',
'statut'=>'masque',   
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'rang'=>180,
),

'bloc_espace'=>array(
'id'=>'espace',
'type'=>'bloc',
'nom'=>'Espace de séparation (remplacé par texte_espace)',
'statut'=>'masque',   
'rang'=>190,
),

);  

}

//==================================================================================

function cibloc_multis_par_defaut() {

return array(

// Le type multi    
    
'multi_colonnes|50|50'=>array(
'id'=>'colonnes|50|50',
'type'=>'multi',
'nom'=>'2 colonnes (50% - 50%)',
'rang'=>10,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.'
),

'multi_colonnes|33|67'=>array(
'id'=>'colonnes|33|67',
'type'=>'multi',
'nom'=>'2 colonnes (33% - 67%)',
'rang'=>20,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.'
),

'multi_colonnes|67|33'=>array(
'id'=>'colonnes|67|33',
'type'=>'multi',
'nom'=>'2 colonnes (67% - 33%)',
'rang'=>30,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.'
),

'multi_colonnes|33|33|33'=>array(
'id'=>'colonnes|33|33|33',
'type'=>'multi',
'nom'=>'3 colonnes (33% - 33% - 33%)',
'rang'=>40,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.'
),

'multi_colonnes|25|25|25|25'=>array(
'id'=>'colonnes|25|25|25|25',
'type'=>'multi',
'nom'=>'4 colonnes (25% - 25% - 25% - 25%)',
'rang'=>50,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.'
),

'multi_colonnes_sans_marge|50|50'=>array(
'id'=>'colonnes_sans_marge|50|50',
'type'=>'multi',
'nom'=>'2 colonnes sans marge avec texte centré (50% - 50%)',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'rang'=>60,
'preremplir'=>'Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.'
),

'multi_colonnes_sans_marge|33|33|33'=>array(
'id'=>'colonnes_sans_marge|33|33|33',
'type'=>'multi',
'nom'=>'3 colonnes sans marge avec texte centré (33% - 33% - 33%)',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'rang'=>70,
'preremplir'=>'<icone|nom=book|echelle=5>Si comes obierit cujus filius nobiscum sit filius.'
),

'multi_colonnes_sans_marge|25|25|25|25'=>array(
'id'=>'colonnes_sans_marge|25|25|25|25',
'type'=>'multi',
'nom'=>'4 colonnes sans marge avec texte centré (25% - 25% - 25% - 25%)',
'bordure'=>'oui',
'couleur_bordure'=>'gris4',
'rang'=>80,
'preremplir'=>'<icone|nom=pagelines|echelle=5>Si autem filium'
),
    
);  

}

//==================================================================================

function cibloc_ensembles_par_defaut() {

return array(
    
// Le type ensemble 
    
'ensemble_liste'=>array(
'id'=>'liste',
'type'=>'ensemble',
'nom'=>'Liste de document et/ou de liens',
'bordure'=>'oui',
'couleur_bordure'=>'gris3',
'couleur_icone'=>'gris6',
'rang'=>0,
'constante'=>'_CIBLOC_BLOC_RESSOURCES_AUTOMATIQUE',
'preremplir'=>'Les documents (ainsi que liens insérés avec la syntaxe de SPIP), {{précédés par un retour à la ligne}}, sont {{automatiquement}} transformés en liste lors du calcul de la page (sauf ceux dans un bloc ou dans un tableau SPIP).
<demodoc|nom=document1>
<demodoc|nom=document2>
[Titre du lien->https://www.google.fr]'
),

'ensemble_exemple1'=>array(
'id'=>'exemple1',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 1',
'rang'=>10,
'preremplir'=>'[multi_colonnes]
[colonne_50]
[bloc_ombre]
<demoimage|nom=image6>
{{{Intertitre A}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/bloc_ombre]
[/colonne_50]
[colonne_50]
[bloc_ombre]
<demoimage|nom=image8>
{{{Intertitre B}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/bloc_ombre]
[/colonne_50]
[/multi_colonnes]'
),

'ensemble_exemple2'=>array(
'id'=>'exemple2',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 2',
'rang'=>20,
'preremplir'=>'[bloc_gris2]
[multi_colonnes]
[colonne_50]
{{{Intertitre}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris.
[/colonne_50]
[colonne_50]
<demoimage|nom=image2>
[/colonne_50]
[/multi_colonnes]
[/bloc_gris2]'
),

'ensemble_exemple3'=>array(
'id'=>'exemple3',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 3',
'rang'=>30,
'preremplir'=>'[bloc_gris]
[multi_colonnes]
[colonne_50]
{{{Intertitre A}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/colonne_50]
[colonne_50]
{{{Intertitre B}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/colonne_50]
[/multi_colonnes]
[/bloc_gris]'
),

'ensemble_exemple4'=>array(
'id'=>'exemple4',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 4',
'rang'=>40,
'preremplir'=>'[multi_colonnes]
[colonne_50]
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur. Si autem filium parvulum habuerit, isdem cum ministerialibus.
[/colonne_50]
[colonne_50]
<demoimage|nom=image10>
[/colonne_50]
[/multi_colonnes]'
),

'ensemble_exemple5'=>array(
'id'=>'exemple5',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 5',
'rang'=>50,
'preremplir'=>'[multi_colonnes]
[colonne_50]
[bloc_imagebas]
<demoimage|nom=image6>
[texte_bas]
[Exemple de lien->http://www.google.fr]
[/texte_bas]
[/bloc_imagebas]
[/colonne_50]
[colonne_50]
[bloc_imagebas]
<demoimage|nom=image8>
[texte_bas]
[Exemple de lien->http://www.google.fr]
[/texte_bas]
[/bloc_imagebas]
[/colonne_50]
[/multi_colonnes]'
),

'ensemble_exemple6'=>array(
'id'=>'exemple6',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 6',
'rang'=>60,
'preremplir'=>'[multi_colonnes]
[colonne_33]
<icone|nom=bar-chart-o|echelle=5|center>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[colonne_33]
<icone|nom=edit|echelle=5|center>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[colonne_33]
<icone|nom=cubes|echelle=5|center>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[/multi_colonnes]'
),

'ensemble_exemple7'=>array(
'id'=>'exemple7',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 7',
'rang'=>70,
'preremplir'=>'[multi_colonnes]
[colonne_33]
{{{<icone|nom=comment-o|echelle=2> Intertitre A}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[colonne_33]
{{{<icone|nom=bar-chart-o|echelle=2> Intertitre B}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[colonne_33]
{{{<icone|nom=user-o|echelle=2> Intertitre C}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[/multi_colonnes]'
),

'ensemble_exemple8'=>array(
'id'=>'exemple8',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 8',
'rang'=>80,
'preremplir'=>'[multi_colonnes]
[colonne_33]
<demoimage|nom=image4>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[colonne_33]
<demoimage|nom=image5>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[colonne_33]
<demoimage|nom=image7>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit.
[/colonne_33]
[/multi_colonnes]'
),

'ensemble_exemple9'=>array(
'id'=>'exemple9',
'type'=>'ensemble',
'nom'=>'Ensemble de blocs 9',
'rang'=>90,
'preremplir'=>'[multi_colonnes_sans_marge]
[colonne_25]
[<icone|nom=lightbulb-o|echelle=5>Si autem filium->https://www.google.fr/]
[/colonne_25]
[colonne_25]
<icone|nom=pagelines|echelle=5>Si autem filium
[/colonne_25]
[colonne_25]
<icone|nom=book|echelle=5>Si autem filium
[/colonne_25]
[colonne_25]
<icone|nom=pie-chart|echelle=5>Si autem filium
[/colonne_25]
[/multi_colonnes_sans_marge]

[multi_colonnes_sans_marge]
[colonne_25]
<icone|nom=map|echelle=5>Si autem filium
[/colonne_25]
[colonne_25]
<icone|nom=map-marker|echelle=5>Si autem filium
[/colonne_25]
[colonne_25]
<icone|nom=eye|echelle=5>Si autem filium
[/colonne_25]
[colonne_25]
<icone|nom=puzzle-piece|echelle=5>Si autem filium
[/colonne_25]
[/multi_colonnes_sans_marge]'
),

'ensemble_pageliste'=>array(
'id'=>'pageliste',
'type'=>'ensemble',
'nom'=>'Page avec des blocs, une liste de documents et une liste de liens',
'rang'=>100,
'constante'=>'_CIBLOC_BLOC_RESSOURCES_AUTOMATIQUE',
'preremplir'=>'{{{Intertitre}}}
Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur. Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. Si vero filium non habuerit, filius noster, cum ceteris fidelibus nostris.
<demodoc|nom=document1>
<demodoc|nom=document2>

[bloc_bouton]
{{{Intertitre}}}
[bouton_gris][Exemple de lien->http://www.google.fr][/bouton_gris]
[/bloc_bouton]

{{{Intertitre}}}
Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur. Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. Si vero filium non habuerit, filius noster, cum ceteris fidelibus nostris.

[Titre du premier lien->https://www.google.fr]
[Titre du second lien->https://www.google.fr]

[bloc_accordeon]
{{{Question}}}
réponse
{{{Question}}}
réponse
{{{Question}}}
réponse
[/bloc_accordeon]'
),

'ensemble_page1'=>array(
'id'=>'page1',
'type'=>'ensemble',
'nom'=>'Page de blocs 1',
'rang'=>110,
'preremplir'=>'{{{Intertitre A}}}
Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur. Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. Si vero filium non habuerit, filius noster, cum ceteris fidelibus nostris.

[multi_colonnes]
[colonne_50]
[bloc_imagebas]
<demoimage|nom=image6>
[texte_bas]
[Exemple de lien->http://www.google.fr]
[/texte_bas]
[/bloc_imagebas]
[/colonne_50]
[colonne_50]
[bloc_imagebas]
<demoimage|nom=image8>
[texte_bas]
[Exemple de lien->http://www.google.fr]
[/texte_bas]
[/bloc_imagebas]
[/colonne_50]
[/multi_colonnes]

{{{Intertitre B}}}
Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur. Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. Si vero filium non habuerit, filius noster, cum ceteris fidelibus nostris.

[multi_colonnes]
[colonne_33]
<demoimage|nom=image4>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/colonne_33]
[colonne_33]
<demoimage|nom=image5>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/colonne_33]
[colonne_33]
<demoimage|nom=image7>
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/colonne_33]
[/multi_colonnes]'
),

'ensemble_page2'=>array(
'id'=>'page2',
'type'=>'ensemble',
'nom'=>'Page de blocs 2',
'rang'=>120,
'preremplir'=>'[multi_colonnes]
[colonne_67]

[bloc_ombre]
{{{<icone|nom=edit|echelle=2> Titre A}}}
<demoimage|nom=image1_large>
Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur.
[/bloc_ombre]


[bloc_ombre]
{{{<icone|nom=eye|echelle=2> Titre B}}}
Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur.

Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur. 
[/bloc_ombre]

[/colonne_67]
[colonne_33]

[bloc_ombre]
{{{<icone|nom=comment-o|echelle=2> Titre C}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/bloc_ombre]

[bloc_ombre]
{{{<icone|nom=bar-chart|echelle=2> Titre D}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/bloc_ombre]

[bloc_ombre]
{{{<icone|nom=user-o|echelle=2> Titre E}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat.
[/bloc_ombre]

[/colonne_33]
[/multi_colonnes]'
),

'ensemble_page3'=>array(
'id'=>'page3',
'type'=>'ensemble',
'nom'=>'Page de blocs 3',
'rang'=>130,
'preremplir'=>'[multi_colonnes]
[colonne_50]
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur. Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. 
[/colonne_50]
[colonne_50]
<demoimage|nom=image10>
[/colonne_50]
[/multi_colonnes]

[bloc_gris2]
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius comitatus et episcopo, in cujus parochia consistit, eundem comitatum pravideat, donec ad nostram notitiam perveniat. Si comes obierit, cujus filius nobiscum sit, filius noster, cum ceteris fidelibus nostris, ordinet de his qui illi plus familiares et propinquiores fuerint, qui cum ministerialibus ipsius comitatus et episcopo ipsum comitatum praevideat, usque dum nobis renuntietur. 
[/bloc_gris2]

[multi_colonnes_sans_marge]
[colonne_25]
<icone|nom=lightbulb-o|echelle=5>Si autem filium
[/colonne_25]
[colonne_25]
<icone|nom=pagelines|echelle=5>Si autem filium
[/colonne_25]
[colonne_25]
<icone|nom=book|echelle=5>Si autem filium
[/colonne_25]
[colonne_25]
<icone|nom=pie-chart|echelle=5>Si autem filium
[/colonne_25]
[/multi_colonnes_sans_marge]

[bloc_image]
<demoimage|nom=image3_large>
[texte_dessus]
{{{Intertitre}}}
Si autem filium parvulum habuerit, isdem cum ministerialibus ipsius filius.
[bouton_blancvide][Exemple de lien->http://www.google.fr][/bouton_blancvide]
[/texte_dessus]
[/bloc_image]'
),
    
);  

}

//==================================================================================
/*
 * Colonnes (type interne)
 * ainsi que l'item "colonnes" (id interne indispensable) de type "multi"
 * L'id d'une colonne est sa largeur exprimee en pourcentage (sans le caractere %)
 */

function cibloc_colonnes_par_defaut() {

return array(

// Le type colonne (interne)    
    
'multi_colonnes'=>array(
'id'=>'colonnes',
'type'=>'multi',
'nom'=>'Multi colonnes',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="">',
'code_html_fermant'=>'</div>',
),

'multi_colonnes_sans_marge'=>array(
'id'=>'colonnes_sans_marge',
'type'=>'multi',
'nom'=>'Multi colonnes sans marge',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="">',
'code_html_fermant'=>'</div>',
),

'colonne_25'=>array(
'id'=>'25',
'type'=>'colonne',
'nom'=>'Colonne 25%',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="col-sm-3">',
'code_html_fermant'=>'</div>',
),

'colonne_33'=>array(
'id'=>'33',
'type'=>'colonne',
'nom'=>'Colonne 33%',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="col-sm-4">',
'code_html_fermant'=>'</div>',
),

'colonne_50'=>array(
'id'=>'50',
'type'=>'colonne',
'nom'=>'Colonne 50%',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="col-sm-6">',
'code_html_fermant'=>'</div>',
),

'colonne_67'=>array(
'id'=>'67',
'type'=>'colonne',
'nom'=>'Colonne 67%',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="col-sm-8">',
'code_html_fermant'=>'</div>',
),

'colonne_75'=>array(
'id'=>'75',
'type'=>'colonne',
'nom'=>'Colonne 75%',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="col-sm-9">',
'code_html_fermant'=>'</div>',
),
    
);  

}

//==================================================================================

function cibloc_textes_par_defaut() {

return array(
    
// Le type texte (interne)    
    
'texte_dessus'=>array(
'id'=>'dessus',
'type'=>'texte',
'nom'=>'Texte par dessus',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="cibloc_texte_dessus_wrapper"><div class="cibloc_texte_dessus">',
'code_html_fermant'=>'</div></div>',
),

'texte_bas'=>array(
'id'=>'bas',
'type'=>'texte',
'nom'=>'Texte en bas',
'statut'=>'masque',   
'code_html_ouvrant'=>'<div class="cibloc_texte_bas_wrapper"><div class="cibloc_texte_bas">',
'code_html_fermant'=>'</div></div>',
),

'texte_trait'=>array(
'id'=>'trait',
'type'=>'texte',
'nom'=>'Trait de séparation',
'code_html_ouvrant'=>'<div class="cibloc_texte_trait">',
'code_html_fermant'=>'</div>',
),

'texte_espace'=>array(
'id'=>'espace',
'type'=>'texte',
'nom'=>'Espace de séparation',
'code_html_ouvrant'=>'<div class="cibloc_texte_espace">',
'code_html_fermant'=>'</div>',
),

'texte_left'=>array(
'id'=>'left',
'type'=>'texte',
'nom'=>'Texte aligné à gauche',
'code_html_ouvrant'=>'<div class="cibloc_texte_left_wrapper"><div class="cibloc_texte_left">',
'code_html_fermant'=>'</div></div>',
'preremplir'=>'Si autem filium parvulum habuerit.'
),

'texte_center'=>array(
'id'=>'center',
'type'=>'texte',
'nom'=>'Texte centré',
'code_html_ouvrant'=>'<div class="cibloc_texte_center_wrapper"><div class="cibloc_texte_center">',
'code_html_fermant'=>'</div></div>',
'preremplir'=>'Si autem filium parvulum habuerit.'
),

'texte_right'=>array(
'id'=>'right',
'type'=>'texte',
'nom'=>'Texte aligné à droite',
'code_html_ouvrant'=>'<div class="cibloc_texte_right_wrapper"><div class="cibloc_texte_right">',
'code_html_fermant'=>'</div></div>',
'preremplir'=>'Si autem filium parvulum habuerit.'
),
    
    
);  

}

//==================================================================================

function cibloc_boutons_par_defaut() {

return array(

    
// Les boutons    
    
'bouton_defaut'=>array(
'id'=>'defaut',
'type'=>'bouton',
'nom'=>'Bouton defaut',
'couleur_bouton'=>'gris5',
'couleur_bouton_survol'=>'noir2',
'code_html_ouvrant'=>'<span class="cibtn cibtn-defaut">',
'code_html_fermant'=>'</span>',
),

'bouton_defautvide'=>array(
'id'=>'defautvide',
'type'=>'bouton',
'nom'=>'Bouton defautvide',
'couleur_bouton'=>'gris5',
'couleur_bouton_survol'=>'noir2',
'transparent'=>'oui',
'code_html_ouvrant'=>'<span class="cibtn cibtn-defautvide">',
'code_html_fermant'=>'</span>',
),

'bouton_gris'=>array(
'id'=>'gris',
'type'=>'bouton',
'nom'=>'Bouton gris',
'couleur_bouton'=>'gris6',
'couleur_bouton_survol'=>'noir2',
'code_html_ouvrant'=>'<span class="cibtn cibtn-gris">',
'code_html_fermant'=>'</span>',
),

'bouton_grisvide'=>array(
'id'=>'grisvide',
'type'=>'bouton',
'nom'=>'Bouton grisvide',
'couleur_bouton'=>'gris6',
'couleur_bouton_survol'=>'noir2',
'transparent'=>'oui',
'code_html_ouvrant'=>'<span class="cibtn cibtn-grisvide">',
'code_html_fermant'=>'</span>',
),

'bouton_blanc'=>array(
'id'=>'blanc',
'type'=>'bouton',
'nom'=>'Bouton blanc',
'couleur_bouton'=>'blanc',
'couleur_bouton_survol'=>'noir2',
'code_html_ouvrant'=>'<span class="cibtn cibtn-blanc">',
'code_html_fermant'=>'</span>',
),

'bouton_blancvide'=>array(
'id'=>'blancvide',
'type'=>'bouton',
'nom'=>'Bouton blancvide',
'couleur_bouton'=>'blanc',
'couleur_bouton_survol'=>'noir2',
'transparent'=>'oui',
'code_html_ouvrant'=>'<span class="cibtn cibtn-blancvide">',
'code_html_fermant'=>'</span>',
),

'bouton_noir'=>array(
'id'=>'noir',
'type'=>'bouton',
'nom'=>'Bouton noir',
'couleur_bouton'=>'noir2',
'couleur_bouton_survol'=>'gris6',
'code_html_ouvrant'=>'<span class="cibtn cibtn-noir">',
'code_html_fermant'=>'</span>',
),

'bouton_noirvide'=>array(
'id'=>'noirvide',
'type'=>'bouton',
'nom'=>'Bouton noirvide',
'couleur_bouton'=>'noir2',
'couleur_bouton_survol'=>'noir2',
'transparent'=>'oui',
'code_html_ouvrant'=>'<span class="cibtn cibtn-noirvide">',
'code_html_fermant'=>'</span>',
),

'bouton_couleur1'=>array(
'id'=>'couleur1',
'type'=>'bouton',
'nom'=>'Bouton couleur1',
'couleur_bouton'=>'couleur1',
'couleur_bouton_survol'=>'noir2',
'code_html_ouvrant'=>'<span class="cibtn cibtn-couleur1">',
'code_html_fermant'=>'</span>',
),

'bouton_couleur1vide'=>array(
'id'=>'couleur1vide',
'type'=>'bouton',
'nom'=>'Bouton couleur1vide',
'couleur_bouton'=>'couleur1',
'couleur_bouton_survol'=>'noir2',
'transparent'=>'oui',
'code_html_ouvrant'=>'<span class="cibtn cibtn-couleur1vide">',
'code_html_fermant'=>'</span>',
),

'bouton_couleur2'=>array(
'id'=>'couleur2',
'type'=>'bouton',
'nom'=>'Bouton couleur2',
'couleur_bouton'=>'couleur2',
'couleur_bouton_survol'=>'noir2',
'code_html_ouvrant'=>'<span class="cibtn cibtn-couleur2">',
'code_html_fermant'=>'</span>',
),

'bouton_couleur2vide'=>array(
'id'=>'couleur2vide',
'type'=>'bouton',
'nom'=>'Bouton couleur2vide',
'couleur_bouton'=>'couleur2',
'couleur_bouton_survol'=>'noir2',
'transparent'=>'oui',
'code_html_ouvrant'=>'<span class="cibtn cibtn-couleur2vide">',
'code_html_fermant'=>'</span>',
),

'bouton_couleur3'=>array(
'id'=>'couleur3',
'type'=>'bouton',
'nom'=>'Bouton couleur3',
'couleur_bouton'=>'couleur3',
'couleur_bouton_survol'=>'noir2',
'code_html_ouvrant'=>'<span class="cibtn cibtn-couleur3">',
'code_html_fermant'=>'</span>',
),

'bouton_couleur3vide'=>array(
'id'=>'couleur3vide',
'type'=>'bouton',
'nom'=>'Bouton couleur3vide',
'couleur_bouton'=>'couleur3',
'couleur_bouton_survol'=>'noir2',
'transparent'=>'oui',
'code_html_ouvrant'=>'<span class="cibtn cibtn-couleur3vide">',
'code_html_fermant'=>'</span>',
),
    
);  

}

//==================================================================================

function cibloc_icones_tableau_par_defaut() {

return array(
'book',
'newspaper-o',
'paste',
'map',
'map-marker',
'leanpub',
'calendar',
'calendar-o',
'list-alt',
'tasks',
'inbox',
'stack-overflow',
'credit-card',
'archive',
'pencil',
'pencil-square',
'pencil-square-o',
'envelope',
'envelope-o',
'envelope-square',
'comment',
'comment-o',
'comments',
'comments-o',
'briefcase',
'suitcase',
'medkit',
'calculator',
'exclamation',
'exclamation-circle',
'exclamation-triangle',
'question',
'question-circle',
'info',
'info-circle',
'eye',
'eye-slash',
'binoculars',
'bell',
'bell-o',
'clock-o',
'compass',
'user',
'user-o',
'group',
'user-secret',
'wheelchair',
'key',
'life-saver',
'lightbulb-o',
'magic',
'plug',
'puzzle-piece',
'heart',
'heartbeat',
'heart-o',
'pie-chart',
'line-chart',
'bar-chart-o',
'signal',
'sellsy',
'sitemap',
'tachometer',
'cube',
'cubes',
'code-fork',
'wrench',
'gear',
'gears',
'random',
'bicycle',
'bus',
'train',
'subway',
'motorcycle',
'automobile',
'taxi',
'truck',
'ship',
'plane',
'home',
'building',
'building-o',
'institution',
'mobile',
'tablet',
'laptop',
'desktop',
'database',
'keyboard-o',
'phone',
'phone-square',
'lock',
'unlock',
'unlock-alt',
'smile-o',
'meh-o',
'frown-o',    
'image',
'film',
'camera',
'camera-retro',
'video-camera',
'music',
'headphones',
'volume-up',
'bullhorn',
'flag',
'flag-checkered',
'flag-o',
'tag',
'tags',
'pagelines',
'leaf',
'tree',
'paw',
'sun-o',
'moon-o',
'cloud',
'umbrella',
'bookmark',
'bookmark-o',
'ticket',
'asterisk',
'ban',
'search',
'recycle',
'thumb-tack',
'dropbox',
'slack',
'dot-circle-o',
'eraser',
'fire',
'fire-extinguisher',
'globe',
'road',    
'gavel',
'graduation-cap',
'gift',
'birthday-cake',
'coffee',
'cutlery',
'spoon',
'glass',
'bitbucket',
'bitbucket-square',
'thumbs-o-up',
'thumbs-up',
'hand-o-down',
'hand-o-left',
'hand-o-right',
'hand-o-up',
'check',
'check-circle',
'check-circle-o',
'check-square',
'check-square-o',
'times',
'times-circle',
'times-circle-o',
'plus-circle',
'plus-square',
'plus-square-o',
'minus-circle',
'minus-square',
'minus-square-o',
'arrow-circle-down',
'arrow-circle-left',
'arrow-circle-right',
'arrow-circle-up',
'arrow-circle-o-down',
'arrow-circle-o-left',
'arrow-circle-o-right',
'arrow-circle-o-up',
'arrow-down',
'arrow-left',
'arrow-right',
'arrow-up',
'chevron-circle-down',
'chevron-circle-left',
'chevron-circle-right',
'chevron-circle-up',
'caret-square-o-down',
'caret-square-o-left',
'caret-square-o-right',
'caret-square-o-up'
);  

}

//==================================================================================

function cibloc_icones_couleur_par_defaut() {

return array(
    
// Les icones    
    
'icone_defaut'=>array(
'id'=>'defaut',
'type'=>'icone',
'nom'=>'defaut',
'couleur_icone'=>'gris5',
),

'icone_gris'=>array(
'id'=>'gris',
'type'=>'icone',
'nom'=>'gris',
'couleur_icone'=>'gris6',
),

'icone_blanc'=>array(
'id'=>'blanc',
'type'=>'icone',
'nom'=>'blanc',
'couleur_icone'=>'blanc',
),

'icone_noir'=>array(
'id'=>'noir',
'type'=>'icone',
'nom'=>'noir',
'couleur_icone'=>'noir2',
),

'icone_couleur1'=>array(
'id'=>'couleur1',
'type'=>'icone',
'nom'=>'couleur1',
'couleur_icone'=>'couleur1',
),

'icone_couleur2'=>array(
'id'=>'couleur2',
'type'=>'icone',
'nom'=>'couleur2',
'couleur_icone'=>'couleur2',
),

'icone_couleur3'=>array(
'id'=>'couleur3',
'type'=>'icone',
'nom'=>'couleur3',
'couleur_icone'=>'couleur3',
),
    
);  

}

//==================================================================================

function cibloc_divers_par_defaut(){

return array(
    'margin_top'=>'1.0',
    'margin_bottom'=>'1.0',
    'bord_multisansmarge' => 'gris4',
    'texte_trait' => 'gris4',
    'bloc_ressource_automatique' => 'non',
    'bord_ressource' => 'gris3',
    'icone_ressource' => 'gris6'
);

}

?>