<?php
/**
 * Plugin cid
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/genie');


function exec_cid_gerer_cron(){

	if (!autoriser('configurer', 'configuration')) {
		include_spip('inc/minipres');
		echo minipres();
	} else {
	
		$commencer_page = charger_fonction('commencer_page', 'inc');
		echo $commencer_page(_T('titre_page_configuration'), "configuration", "configuration");
		
		echo "<br />\n";
		echo gros_titre('Gestion des t&acirc;ches de fond','', false);
		
		echo debut_gauche('', true);
	
		echo creer_colonne_droite('', true);
		echo debut_droite('', true);
	
		if (_request('tache')) {
			$tache = _request('tache');
			$taches = taches_generales();
			if (isset($taches[$tache])) {
				$lock = _DIR_TMP . $tache . '.lock';
				$last = @filemtime($lock);
				spip_timer('tache');
				spip_log('cron: debut '.$tache, 'genie');
				touch($lock);
				$cron = charger_fonction($tache, 'genie');
				$retour = $cron($last);
				// si la tache a eu un effet : log
				if ($retour) {
					if ($tache=='syndic') {
						$row = sql_fetsel("nom_site", "spip_syndic", "id_syndic=".intval($retour));
						$msgretour = $tache." : fait pour le site : ".interdire_scripts(entites_html($row['nom_site']));
					} elseif ($retour == 1 OR $tache=='optimiser') {
						$msgretour = $tache." : fait";
					} else {			
						$msgretour = $tache." : fait (".$retour.")";
					}

					spip_log("cron: $tache (" . spip_timer('tache') . ") $retour", 'genie');
					if ($retour < 0 AND $tache!='optimiser')
						@touch($lock, 0 - $retour);
				} else {
					if ($tache=='syndic')
						$msgretour = $tache." : syndication déjà à jour";
				}
			}
				
		}
		
		echo cid_liste_cron($msgretour);
	
	
		echo fin_gauche(), fin_page();
	}
}


function cid_liste_cron($msgretour) {
    $texte = "";
	$taches = taches_generales();
	$tmin = time();

	foreach ($taches as $nom => $periode) {
		$celock = _DIR_TMP . $nom . '.lock';
		$date_lock = @filemtime($celock);
		if ($date_lock) {
			$msg = date("d/m/y H:i:s", $date_lock);
			$ilya = date("H:i:s",$tmin-$date_lock-3600);			
		} else {
			$msg = "";
			$ilya = "";
		}


		$texte .= "<tr><td><a href='".generer_url_ecrire("cid_gerer_cron","tache=".$nom)."'>".$nom."</a></td><td>"
				.cid_convertir_secondes($periode)."</td><td>".$msg."</td><td>".$ilya."</td></tr>\n";

	}
    
    if ($texte) {
		$texte = debut_cadre_relief('',true,'','Gestion des t&acirc;ches de fond')
		.'<table cellspacing="0" cellpadding="2" style="width: 100%; border: 0px none;" class="arial2"><tbody>
		<tr style="background-color:#eee;">
		<th style="width: 30%;">T&acirc;che de fond</th><th style="width: 30%;">Intervalle théorique</th>
		<th style="width: 30%;">Dernière réalisation le</th><th style="width: 10%;">Il y a</th>
		</tr>'
	    . $texte
		.'</tbody></table>'
		.'<br/>'.$msgretour.'<br/>'
	    . fin_cadre_relief(true);
		
		
    }

	return $texte;  
}	

function cid_convertir_secondes($total) {
	$return = "";
	$heure = intval($total / 3600);
	$total = $total - ($heure * 3600);
	$minute = intval($total / 60);
	$total = $total - ($minute * 60);
	$seconde = $total;

	if ($heure!=0)
		$return = $heure." h";
		
	if ($minute!=0 OR ($heure!=0 AND $seconde!=0)) {
		if ($return) $return .= " ";
		$return .= $minute." min";
	}
	
	if ($seconde!=0) {
		if ($return) $return .= " ";
		$return .= $seconde." sec";
	}

	return $return;	
}
?>