<?php
/**
 * Plugin cid : Fonctions diverses
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/actions');
include_spip('inc/editer');
include_spip('inc/cisf_commun');
include_spip('inc/cid_inc_commun');

function formulaires_cid_cisf_datefin_charger_dist($id_article='new', $id_rubrique=0, $retour='', $lier_trad=0, $config_fonc='articles_edit_config', $row=array(), $hidden='')
{
	
	if (!autoriser('modifier', 'article', $id_article))
		return false;

	if (cisf_indesirable())
		return false;

	$valeurs = array();
	$valeurs['id_article'] = $id_article;

	$result = sql_select("datefin", "spip_cid_datefin", "id_objet=".$id_article." AND objet='article'","","");	
	while ($row = sql_fetch($result)) {
		$valeurs['_datefin_article'] = $row['datefin'];
	}
				
	$valeurs['_hidden'] = "<input type='hidden' name='id_article' value='$id_article' />"
						. "<input type='hidden' name='id_rubrique' value='$id_rubrique' />";

	// Pour SPIP 2.1
	$valeurs['id_rubrique'] = $id_rubrique;
	
	// Imperatif : preciser que le formulaire doit etre securise auteur/action
	// sinon rejet
	$valeurs['_action'] = array("cisf_datefin",$id_article);
	

	return $valeurs;
}

function formulaires_cid_cisf_datefin_verifier_dist($id_article='new', $id_rubrique=0, $retour='', $lier_trad=0, $config_fonc='articles_edit_config', $row=array(), $hidden='')
{
	$erreurs = array();
	if (!_request('supprimer_datefin_article'))
		$erreurs = cid_verifier_date(_request('datefindepublication'),_request('heurefindepublication'));

	return $erreurs;	
}

function formulaires_cid_cisf_datefin_traiter_dist($id_article='new', $id_rubrique=0, $retour='', $lier_trad=0, $config_fonc='articles_edit_config', $row=array(), $hidden='')
{
	$res = array();
        
	// Preparation de l'aiguillage
	$fond = "cisf_article";
	$retour = generer_url_public("$fond", "id_article=$id_article&id_rubrique=$id_rubrique");
	
	if (!isset($_POST['annuler']))
		cid_maj_datefin($id_article,_request('datefindepublication'),_request('heurefindepublication'),_request('supprimer_datefin_article'));
	
	$res['message_ok'] = "";
	$res['redirect'] = $retour;

	return $res;
}

?>