<?php
/**
 * Plugin cid : Fonctions diverses
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/filtres');

function inc_cid_rubrique_dist($id_rubrique, $statut)
{

	// cf autorisations dans action/editer_rubrique
	if (!autoriser('modifier', 'rubrique', $id_rubrique)) return '';

	$href = redirige_action_auteur('cid_rubrique',$id_rubrique,'rubrique', "id_rubrique=$id_rubrique");
	
	$res = '';
	if ($statut=='0')
		$statut = 'prive';

	if ($statut=='new')
		$etats = array(
			'texte_statut_en_cours_redaction' => 'new',
			'texte_statut_publie' => 'publie'
			);
	elseif ($statut=='prepa')
		$etats = array(
			'texte_statut_en_cours_redaction' => 'prepa',
			'texte_statut_publie' => 'publie'
			);
	else
		$etats = array(
			'texte_statut_en_cours_redaction' => 'prive',
			'texte_statut_publie' => 'publie'
			);

	// Ne pas proposer de depublier une rubrique qui a des objets publies
	if ($statut=='publie') {
		$row = sql_fetsel('date', "spip_rubriques", "id_rubrique=$id_rubrique",'', '');
		if ($row['date'] != "0000-00-00 00:00:00")
			$etats = array('texte_statut_publie' => 'publie');
	}
			
	$res .=
	  "<ul id='instituer_rubrique-$id_rubrique' class='instituer_rubrique instituer'>" 
	  . "<li>" 
	  ."<ul>";
	

	foreach($etats as $affiche => $s){
		$puce = puce_statut($s) . _T($affiche);
		if ($s=='new' OR $s=='prive' OR $s=='prepa')
			$puce = puce_statut('prepa') . _T($affiche);
		if ($s==$statut)
			$class=' selected';
		else {
			$class=''; 
			$puce = "<a href='"
			. parametre_url($href,'statut_nouv',$s)
			. "' onclick='return confirm(confirm_changer_statut);'>$puce</a>";
		}
		$res .= "<li class='$s $class'>$puce</li>";
	}

	$res .= "</ul></li></ul>";
  
	return $res;
}

?>