<?php
/**
 * Plugin Formulaire
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 *
 * Syntaxe � mettre dans un squelette :
 * #FORMULAIRE_CIFORM_REDIGER{#SELF} 
 */

include_spip('action/editer_article'); // pour insert_article
include_spip('inc/texte');	// pour safehtml et inc/filtres
include_spip('inc/ciform_commun');


function formulaires_ciform_rediger_charger_dist($retour=''){

	$valeurs = array('nom'=>'', 'email'=>'', 'rubrique'=>'', 'titre'=>'', 'texte'=>'', 'descriptif'=>'');

        // si authentifie
        if (isset($GLOBALS['visiteur_session']['email']) AND trim($GLOBALS['visiteur_session']['email']))
            $valeurs['email'] = $GLOBALS['visiteur_session']['email'];
        
        if (isset($GLOBALS['visiteur_session']['nom']) AND trim($GLOBALS['visiteur_session']['nom']))
            $valeurs['nom'] = $GLOBALS['visiteur_session']['nom'];
        
	// liste des rubriques possibles pour proposer l'article
	// si pas de rubrique, le formulaire ne sera pas actif
	$rediger_actif = 'non';
	$res = "";

	if (defined('_DIR_PLUGIN_CIPARAM')) {
		$result = sql_select("rub.id_rubrique, rub.titre", "spip_rubriques AS rub, spip_ci_raccourcis_rubriques AS lien", "rub.id_rubrique=lien.id_rubrique AND lien.raccourci='_recevoirarticlevisiteur' AND rub.statut='publie'", "", "rub.titre");
		while ($row = sql_fetch($result)) { 
      		$res .=	'<option value="'.$row['id_rubrique'].'">'.interdire_scripts(supprimer_numero($row['titre'])).'&nbsp;</option>';
      		$rediger_actif = 'oui';
		}
	} else {
		$row_mot = sql_fetsel("id_mot", "spip_mots", "titre='_recevoirarticlevisiteur'","","");
		if ($row_mot) {
			$id_mot = $row_mot['id_mot'];
			$result = sql_select("rub.id_rubrique, rub.titre", "spip_rubriques AS rub, spip_mots_liens AS lien", "lien.objet='rubrique' AND rub.id_rubrique=lien.id_objet AND lien.id_mot=".$id_mot." AND rub.statut='publie'","","rub.titre");
			while ($row = sql_fetch($result)) { 
	      		$res .=	'<option value="'.$row['id_rubrique'].'">'.interdire_scripts(supprimer_numero($row['titre'])).'&nbsp;</option>';
	      		$rediger_actif = 'oui';
			}
		}
	}

	$valeurs['_ciform_rediger_rubrique'] = $res;
	$valeurs['rediger_actif'] = $rediger_actif;
		
	// Antispam
	$valeurs['_hidden'] = "<input type='hidden' name='ciformcle' value='".ciform_cle()."' />";
		
	return $valeurs;
}


function formulaires_ciform_rediger_verifier_dist($retour=''){
	$erreurs = array();
	
	// verifier que les champs obligatoires sont bien la :
	if (!isset($GLOBALS['visiteur_session']['nom']) 
		AND !_request('nom')) 
		$erreurs['nom'] = _T('info_obligatoire');
	
	if (!isset($GLOBALS['visiteur_session']['email']) 
		AND !_request('email')) 
		$erreurs['email'] = _T('info_obligatoire');
		
	foreach(array('rubrique', 'titre') as $obligatoire)
		if (!_request($obligatoire)) $erreurs[$obligatoire] = _T('info_obligatoire');
		
	// id_rubrique est un nombre
	if (intval(_request('rubrique'))<1) $erreurs['rubrique'] = _T('info_obligatoire');
		
	// longueur minimale a respecter
        $request_titre = _request('titre');
        $request_texte = _request('texte');
	if (empty($request_titre) OR strlen($request_titre) < 3) $erreurs['titre'] = _T('ciform:rediger_attention_trois_caracteres');
	if (empty($request_texte) OR strlen($request_texte) < 10) $erreurs['texte'] = _T('ciform:rediger_attention_dix_caracteres');

	// verifier que si un mail a ete saisi, il est bien valide :
	if (_request('email') AND !email_valide(_request('email')))
		$erreurs['email'] = _T('info_email_invalide');
		
	if (count($erreurs)){
		if (defined('_DIR_PLUGIN_CISQUEL')){
                    $erreurs['message_erreur'] = singulier_ou_pluriel(count($erreurs),'cisquel:avis_1_erreur_saisie','cisquel:avis_nb_erreurs_saisie');
                } else {
                    $erreurs['message_erreur'] = _T('avis_erreur');
                }
        }

	return $erreurs;
}


function formulaires_ciform_rediger_traiter_dist($retour=''){
	
	// Antispam
	$cispam = ciform_antispam('rediger', array('texte','descriptif')); 	
	if (isset($cispam) AND is_array($cispam))
		return array('message_ok'=>$cispam['message_erreur']);


	// imp�ratif sinon pas de maj
	$id_article = 'new';
	$id_rubrique = intval(_request('rubrique'));

			
	// securite
        
        // Si CISPAM et qu'on supprime ou echappe le code HTML des forums
        // on fait de meme pour le formulaire ciform_rediger
        if (defined('_DIR_PLUGIN_CISPAM') 
                AND function_exists('cispam_forum_sans_html')
                AND $action = cispam_config('cispam_forum_html_amont')){
            $pseudo = "\n\n"._T('ciform:auteur')." : ";
            if (isset($GLOBALS['visiteur_session']['nom']) AND trim($GLOBALS['visiteur_session']['nom']))
                  $pseudo .= $GLOBALS['visiteur_session']['nom'];
            else
                  $pseudo .= cispam_forum_sans_html(_request('nom'), $action);

            // stocker adresse mail dans le champ ps
            if (isset($GLOBALS['visiteur_session']['email']) AND trim($GLOBALS['visiteur_session']['email']))
                    set_request('ps', $GLOBALS['visiteur_session']['email']);
            else
                    set_request('ps', cispam_forum_sans_html(_request('email'), $action));

            set_request('titre', cispam_forum_sans_html(_request('titre'), $action));
            set_request('descriptif', cispam_forum_sans_html(_request('descriptif'), $action));
            // Mettre le pseudo a la fin du texte
            set_request('texte', cispam_forum_sans_html(_request('texte'), $action).$pseudo);

        } else {
            $pseudo = "\n\n"._T('ciform:auteur')." : ";
            if (isset($GLOBALS['visiteur_session']['nom']) AND trim($GLOBALS['visiteur_session']['nom']))
                  $pseudo .= $GLOBALS['visiteur_session']['nom'];
            else
                  $pseudo .= safehtml(_request('nom'));

            // stocker adresse mail dans le champ ps
            if (isset($GLOBALS['visiteur_session']['email']) AND trim($GLOBALS['visiteur_session']['email']))
                    set_request('ps', $GLOBALS['visiteur_session']['email']);
            else
                    set_request('ps', safehtml(_request('email')));

            set_request('titre', safehtml(_request('titre')));
            set_request('descriptif', safehtml(_request('descriptif')));
            // Mettre le pseudo a la fin du texte
            set_request('texte', safehtml(_request('texte')).$pseudo);
        }	

	// traiter
        if ($GLOBALS['spip_version_branche']>=4) {
                $id_article = article_inserer($id_rubrique);
                if ($id_article > 0) $err = article_modifier($id_article);
        } else {
                $id_article = insert_article($id_rubrique);
                if ($id_article > 0) $err = articles_set($id_article);
        }
	// Mettre le statut prop (directement sinon on se heurte a la gestion des droits) 
	sql_updateq("spip_articles", array("statut" => "prop"), "id_article=$id_article");
	

	// si message d'erreur
	if ($err)
		return array('message_ok'=>_T('avis_erreur').' : '.$err);

	
	// Notifications
	if ($notifications = charger_fonction('notifications', 'inc')) {
		$notifications('instituerarticle', $id_article,
			array('statut' => 'prop', 'statut_ancien' => 'prepa')
		);
	}
	
	return array('message_ok'=>_T('ciform:envoi_effectue'));	
}

?>