<?php
/**
 * Plugin CILIEN
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/actions');
include_spip('inc/editer');
include_spip('inc/cilien');


function formulaires_cilien_remplacer_lien_charger_dist(){

	$valeurs = array();
	
	if (!autoriser('configurer', 'configuration'))
		return;

	$valeurs['ciedit'] = true;

	return $valeurs;
}


function formulaires_cilien_remplacer_lien_verifier_dist(){
        $erreurs = array();

	if (_request('lieninitial')){
            if (!_request('lienfutur')){
		$erreurs['lienfutur'] = _T('info_obligatoire');
            } else {
                if (!cilien_verifier_url(_request('lieninitial')))
                    $erreurs['lieninitial'] =  _T('cilien:valeur_incorrecte');
                elseif (!cilien_verifier_url(_request('lienfutur')))
                    $erreurs['lienfutur'] =  _T('cilien:valeur_incorrecte');
                elseif (sql_countsel("spip_cilien", "url=".sql_quote(_request('lieninitial')))==0)
                    $erreurs['lieninitial'] =  _T('cilien:lien_existe_pas');
            }
        }

	return $erreurs;
}


function formulaires_cilien_remplacer_lien_traiter_dist(){
        $cibreak = false;
        $compte = 0;
        $res = array();

        // remplacer un lien
	if (_request('lieninitial') AND _request('lienfutur')){
            $lieninitial = _request('lieninitial');
            $lienfutur = _request('lienfutur');
            
            $result = sql_select("*", "spip_cilien", "url=".sql_quote($lieninitial));
            $dureemax = 10;	// duree maximum en secondes
            $time = time();
                
            while ($row = sql_fetch($result)) {
                $n = cilien_remplace_dans_objet($lieninitial,$lienfutur,$row['objet'],$row['id_objet']);
                $compte++;
                
//                if ($n>=1)
                    sql_updateq("spip_cilien", array("url"=>$lienfutur), "url=".sql_quote($lieninitial));
                    
                // si plus de dureemax secondes on sort de la boucle
                if ((time() - $time) > $dureemax){
                    $cibreak = true;
                    break;
                }
            }
            
            // traiter aussi les sites references
            $result = sql_select("*", "spip_syndic", "url_site=".sql_quote($lieninitial));
            while ($row = sql_fetch($result)) {
                sql_updateq("spip_syndic", array("url_site"=>str_replace($lieninitial,$lienfutur,$row['url_site']), "url_syndic"=>str_replace($lieninitial,$lienfutur,$row['url_syndic'])), "id_syndic=".$row['id_syndic']);
                $compte = $compte + $n;
            }
            
            if (defined('_DIR_PLUGIN_CITRACE')){
                if ($citrace = charger_fonction('citrace', 'inc')) {
                    include_spip('inc/texte');
                    $message = '(remplacement du lien '.$lieninitial.' par '.$lienfutur.')';							
                    $citrace('lien', '', 'remplacer lien', $message);
                }
            }
            
        }
        
        if ($cibreak)
        	$res['message_ok'] = "Remplacement fait dans ".$compte." objet(s). Traitement partiel. Relancer le traitement.";
        else
        	$res['message_ok'] = "Remplacement fait dans ".$compte." objet(s)";
            
	return $res;	
}

?>