<?php
/**
 * Plugin Saisie facile
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

include_spip('inc/filtres');
include_spip('inc/filtres_ecrire');
include_spip('inc/filtres_boites');

if (isset($GLOBALS['visiteur_session']['id_auteur']) AND $GLOBALS['visiteur_session']['id_auteur'])
        $GLOBALS['connect_id_auteur'] = $GLOBALS['visiteur_session']['id_auteur'];	
 
 
// adapt� de exec_statistiques_visites_dist
function cisf_statistiques_visites($id_article) {
	
	$id_article = intval($id_article);
	$type = _request('type');
	if (!preg_match('/^\w+$/', $type)) $type = 'day';
	$duree = intval(_request('duree'));
	if (!$duree) $duree = 105;
	$interval = intval(_request('interval'));
	if (!$interval) {
	  if ($type == 'day')
	    $interval = 3600*24;
	  else $interval = 3600;
	}

	// nombre de referers a afficher
	$limit = intval(_request('limit'));
	if ($limit == 0) $limit = 100;

	return cisf_statistiques_visites_args($id_article, $duree, $interval, $type, $limit);
}


// adapt� de exec_statistiques_visites_args
function cisf_statistiques_visites_args($id_article, $duree, $interval, $type, $limit,$serveur='') {
	include_spip('inc/presentation');
	include_spip('inc/statistiques');
	
	$return = "";
	$titre = $pourarticle = "";
        $res = array();

	if ($id_article){
		$row = sql_fetsel("titre, visites, popularite", "spip_articles", "statut='publie' AND id_article=$id_article",'','','','',$serveur);

		if ($row) {
			$titre = typo($row['titre']);
			$total_absolu = $row['visites'];
			$val_popularite = round($row['popularite']);
		}
	} else {
		$row = sql_fetsel("SUM(visites) AS total_absolu", "spip_visites",'','','','','',$serveur);
		$total_absolu = $row ? $row['total_absolu'] : 0;
		$val_popularite = 0;
	}

	if ($titre) $pourarticle = " "._T('info_pour')." &laquo; $titre &raquo;";
	if ($serveur) {
		if ($row = sql_fetsel('valeur','spip_meta',"nom='nom_site'",'','','','',$serveur)){
			$titre = $row['valeur'].($titre?" / $titre":"");
		}
	}

	$classement = array();
	$liste = 0;
	

	$return .= "<h2>"._T('titre_evolution_visite');
	if ($titre) $return .= "<br/>".$titre;
	$return .= "</h2><br/>";

	$return .= "<div>".debut_droite('', true);

	if ($id_article) {
			$table = "spip_visites_articles";
			$table_ref = "spip_referers_articles";
			$where = "id_article=$id_article";
			  
	} else {
			$table = "spip_visites";
			$table_ref = "spip_referers";
			$where = "";
	}

	$order = "date";

	$where2 = $duree ? "$order > DATE_SUB(".sql_quote(date('Y-m-d H:i:s')).",INTERVAL $duree $type)": '';
	if ($where) $where2 = $where2 ?  "$where2 AND $where" : $where;
	$log = statistiques_collecte_date('visites', "(CEIL(UNIX_TIMESTAMP($order) / $interval) *  $interval)", $table, $where2, $serveur);

	
	if ($log)
	  $res = statistiques_tous($log, $id_article, $table, $where, $order, $serveur, $duree, $interval, $total_absolu, $val_popularite,  $classement, $liste);
	
	// ne pas renvoyer dans espace prive lors du zoom
	$search = "/ecrire/?exec=statistiques_visites";
	$replace = "/spip.php?page=cisf_statistique";
	$res = str_replace($search,$replace,$res);
	   
	$mois = statistiques_collecte_date("SUM(visites)",
		"FROM_UNIXTIME(UNIX_TIMESTAMP($order),'%Y-%m')", 
		$table,
		"$order > DATE_SUB(NOW(),INTERVAL 2700 DAY)"
		. ($where ? " AND $where" : ''),
		$serveur);

	if (count($mois)>1)  {
		$res[] = "<br /><span class='verdana1 spip_small'><b>"
			. _T('info_visites_par_mois')
			. "</b></span>"
			. statistiques_par_mois($mois, '');
	}

	$cicadre = cadre_stat($res, $table, $id_article);
	// ne pas afficher CSV qui ne fonctionne pas sur le site public
	$cicadre = str_replace("CSV","",$cicadre);
	$return .= $cicadre;

	
	
	if ($id_article) {
		$signatures = charger_fonction('signatures', 'statistiques');
		$cisignatures = $signatures($duree, $interval, $type, $id_article, $serveur);
		$cisignatures = str_replace("h1>","h2>",$cisignatures);
		$cisignatures = str_replace("CSV","",$cisignatures);
		$return .= $cisignatures;
		

		$referenceurs = charger_fonction('referenceurs', 'inc');
		$res = $referenceurs($id_article, "visites", $table_ref, $where, '', $limit);
	
		if ($res) {
	
			// Le lien pour en afficher "plus"
			$args = ($id_article?"id_article=$id_article&" : '') . "limit=" . strval($limit+200);
			$n =  count($res);
			$plus = generer_url_ecrire('statistiques_visites', $args);
			if ($plus) {
				$plus = ($limit == $n)
				? "<div style='text-align:right;'><b><a href='$plus'>+++</a></b></div>"
				: '';
			}
			$titre = _T("onglet_origine_visites")
			. " ($n " 
			. ($n == 1 ?  _T('info_site') :  _T('info_sites'))
			  . ")";
			$return .= '<br /><h2>'.$titre.'</h2>';
			$return .= "<div style='overflow:hidden;' class='verdana1 spip_small'><br />";
			$return .= "<ul class='referers'><li>";
			$return .= join("</li><li>\n",$res);
			$return .= "</li></ul>";
			$return .= $plus;
			$return .= "<br /></div>";	
		}

	}

	return $return;
}


?>