<?php
/**
 * Plugin squelettes de base
 * Auteur : Christophe IMBERTI
 * Licence GPL
 */



function cisquel_choixelargirrecherche($valeur=false) {
	$return = 'non';
	
	// lire la configuration du plugin
	$tableau_config = cisquel_lire_meta();
	
	// choix par defaut
	if (isset($tableau_config['cisquelchoixelargirrecherche']))
		$return = $tableau_config['cisquelchoixelargirrecherche'];

	// choix par url	
	if (isset($tableau_config['cisquelchoixelargirrecherche_selon_host'])) {
		$tableau_urls = $tableau_config['cisquelchoixelargirrecherche_selon_host'];
		if (is_array($tableau_urls)){
			$ci_host = cisquel_url_host();
                        foreach ($tableau_urls as $ciurl => $valurl) {
				// HOST se terminant par ...
				if (substr($ciurl,0,1)=='.') {
					if ($ciurl==substr($ci_host,-strlen($ciurl))){
						$return = $valurl;
						break;
					}
				// HOST qui commence par ...
				} elseif (substr($ciurl,-1)=='.') {
					if ($ciurl==substr($ci_host,0,strlen($ciurl))){
						$return = $valurl;
						break;
					}
				}
			}
		}
	}

	return $return;
}

/**
 * Determination du HOST
 *
 * @param : aucun
 * @return : host
 */
function cisquel_url_host() {

	$ci_host = "";

	// lire la configuration du plugin
	$tableau_config = cisquel_lire_meta();
	
	// ordre de recherche par d�faut
	$cisquelhostordre = array('HTTP_X_FORWARDED_SERVER','SERVER_NAME','HTTP_HOST');
	
	// ordre de recherche personnalise dans le fichier de parametrage config/_config_cisquel.php
	if (isset($tableau_config['cisquelhostordre'])) {
		if (is_array($tableau_config['cisquelhostordre'])) {
			$cisquelhostordre = $tableau_config['cisquelhostordre'];
		}
	}
	
	foreach ($cisquelhostordre as $valeur) {
		if (isset($_SERVER[$valeur])) {
			if ($_SERVER[$valeur]) {
				$ci_host = $_SERVER[$valeur];
				break;
			}
		}
	}

	return $ci_host;
}

function cisquel_url_moteur() {

	$ciurlmoteur = '';
	$ci_host = cisquel_url_host();

	// lire la configuration du plugin
	$tableau_config = cisquel_lire_meta();

	// adresse par defaut du moteur
	$ciurlmoteur = $tableau_config['cisquelmoteururl'];
	
	// autre adresse du moteur selon le type de terminaison de l'adresse d'appel du site SPIP
	if (isset($tableau_config['cisquelmoteursurls_selon_host'])) {
		if (is_array($tableau_config['cisquelmoteursurls_selon_host'])) {
                        foreach ($tableau_config['cisquelmoteursurls_selon_host'] as $terminaison => $valurl) {
				if (substr($ci_host,-strlen($terminaison))==$terminaison) {
					$ciurlmoteur = $valurl;
					break;
				}
			}
		}
	}

	return $ciurlmoteur;	
}

function cisquel_moteur() {

	$cimoteur = '';
	$ci_host = cisquel_url_host();

	// lire la configuration du plugin
	$tableau_config = cisquel_lire_meta();

	// moteur par defaut
	$cimoteur = $tableau_config['cisquelmoteur'];
	
	// autre moteur selon le type de terminaison de l'adresse d'appel du site SPIP
	if (isset($tableau_config['cisquelmoteurs_selon_host'])) {
		if (is_array($tableau_config['cisquelmoteurs_selon_host'])) {
                        foreach ($tableau_config['cisquelmoteurs_selon_host'] as $terminaison => $valurl) {
				if (substr($ci_host,-strlen($terminaison))==$terminaison) {
					$cimoteur = $valurl;
					break;
				}
			}
		}
	}

	return $cimoteur;	
}

function cisquel_getmno($recherche,$env) {
	$contenu = '';
	
	// lire la configuration du plugin
	$tableau_config = cisquel_lire_meta();
	$cisquelgetmnosite = $tableau_config['cisquelgetmnosite'];
	$cisquelgetmnotoussites = $tableau_config['cisquelgetmnotoussites'];	
	
	// indispensable (necessite un #ENV sans filtre)
	$unenv = unserialize($env);
	
	// securite
	$p = cisquel_verifier_parametres($unenv);
	
	
	if (($p['elargir']=='doc' AND $cisquelgetmnosite=='oui') OR ($p['elargir']=='toussites' AND $cisquelgetmnotoussites=='oui')) {
		
		if ($p['elargir']=='toussites' AND $cisquelgetmnotoussites=='oui')
			$toussites = true;
		else
			$toussites = false;

		if ($p['elargir']=='doc' AND $cisquelgetmnosite=='oui')
			$getdoc = true;
		else
			$getdoc = false;
			
		$url = cisquel_url_recherche_mno($p, $toussites, $getdoc);

		// pagination
		if ($p['np'])
			$url .='&np='.$p['np'];
		
		include_spip('inc/distant');
                if ($GLOBALS['spip_version_branche']>=4) {
                        $data = recuperer_url($url);
                        if ($data AND isset($data['page'])){
                            $contenu = $data['page'];
                        } else {
                            $contenu = '';
                        }
                        
                } else {
                	$contenu = recuperer_page($url);
                }
		if ($contenu) {
			$pos1 = strpos($contenu, '<div id="results">');
			$pos2 = strpos($contenu, '<div class="folio">');
			if ($pos1!==false AND $pos2!==false) {
				
				// charset du moteur
				$charset_moteur='iso-8859-1';
				if (preg_match('#<meta (.*?) content=(.*?)>#s', $contenu, $reg)) {
					if (strpos($reg[0], 'charset=utf-8')!==false)
						$charset_moteur='utf-8';
				}

				// Remplacer les liens de pagination
				$pagination = substr($contenu,$pos2);
				$pos3 = strpos($pagination, '</div>');
				$pagination = substr($pagination,0,$pos3).'</div></div>';				
				$self = self();
				if (preg_match_all('#<a href=(.*?)>#', $pagination, $matches)) {
					for ($i=0; $i< count($matches[0]); $i++) {
						$lien = $matches[1][$i];
						if (preg_match('#&amp;np=(.*?)&amp;#',$lien,$r)) {
							list($x,$np)= $r;
							$pagination = str_replace($lien,parametre_url($self,'np',$np),$pagination);
						} else {
							// cas de la premiere page
							$pagination = str_replace($lien,parametre_url($self,'np',0),$pagination);
						}
					}
				}
				
				$contenu = substr($contenu,$pos1+18,($pos2-$pos1-18)) . $pagination;
				
				// elargir au contenu des documents
				// rendre les titres de document lisibles
				if ($getdoc) {
					// option s pour le retour a la ligne
					if (preg_match_all('#<strong><a href=(.*?)>(.*?)</a></strong>#s', $contenu, $matches)) {
						for ($i=0; $i< count($matches[0]); $i++) {
							$titre = $matches[2][$i];
							$titre_propre = $matches[1][$i];
							$titre_propre = str_replace('"',' ',$titre_propre);
							$titre_propre = cisquel_enlever_cle(cisquel_nomfichier($titre_propre));
							$titre_propre = str_replace('_',' ',$titre_propre);
							$contenu = str_replace($titre,$titre_propre,$contenu);
						}
					}
				}
				
				// modifier le chemin des vignettes
				$old = 'images/icones/';
				$new = _DIR_PLUGIN_CISQUEL . '_images/icones/';
				$contenu = str_replace($old,$new,$contenu);
				
				// enlever "vos criteres de recherche ..."
				if (preg_match('#<p class="enteteresult">(.*?)</p>#s', $contenu, $match))
					$contenu = str_replace($match[0],'',$contenu);
				
				// convertir le charset le cas echeant
				if ($charset_moteur!=$GLOBALS['meta']['charset']){
					include_spip('inc/charsets');
					$contenu = importer_charset($contenu, $charset_moteur);
				}
	
				
			} else {
				$contenu = '<p class="enteteresult">0 <strong>';
				if ($toussites)
					$contenu .= _T('cisquel:trouves');
				else
					$contenu .= _T('cisquel:doc_trouves');
					
				$contenu .= '</strong></p>';
			}
		}
	}
	return $contenu;
}

function cisquel_url_recherche_mno($p=array(), $touslessites=false, $getdoc=false) {
	
	// lire la configuration du plugin
	$tableau_config = cisquel_lire_meta();
	$qs = $tableau_config['cisquelmnogosearch'];

	if ($touslessites) {
		$ul = '';
		$site ='';
		$categ = '---+Choisissez+une+cat%E9gorie+---';
		$groupbysite = 'no';
	} else {
		$ul = urlencode($GLOBALS['meta']['adresse_site']);
		$site = 'u%3A'.urlencode($GLOBALS['meta']['adresse_site']);
		$categ = '0';
		$groupbysite = 'no';
	}
	
	// tenir compte des options de recherche
	// et les convertir au format attentdu par mnogosearch
	$s1 = $qs['s'];
	$s2 = $qs['s'];
	$db = '';
	$de = '';
	$type = '';
	
	if ($p) {
		// urlencode remplace au passage les espaces par le signe plus
		// urlencode n'est pas unicode
		if ($GLOBALS['meta']['charset']=='utf-8'){
                        if (function_exists('mb_convert_encoding')) {
                            $recherche = mb_convert_encoding($p['recherche'], 'ISO-8859-1', 'UTF-8');
                        } else {
                            $recherche = urlencode($p['recherche']);
                        }
                } else {
			$recherche = urlencode($p['recherche']);
                }
                
		if ($p['tri']=='date'){
			$s1 = 'dR';
			$s2 = 'dR';
			$qs['avancee'] = 'yes';
		} elseif ($p['tri']=='datedesc'){
			$s1 = 'DR';
			$s2 = 'DR';
			$qs['avancee'] = 'yes';
		}

		if ($p['age']) {
			$qs['dp'] = $p['age'].'d';
			$qs['avancee'] = 'yes';
		}

		if ($p['datedebut']){
			$db = '&db='.$p['datedebut'];
			$qs['dt'] = 'range';
			$qs['avancee'] = 'yes';
		}

		if ($p['datefin']){
			$de = '&de='.$p['datefin'];
			$qs['dt'] = 'range';
			$qs['avancee'] = 'yes';
		}

		if ($p['typedoc']){
			$qs['avancee'] = 'yes';
			$row = sql_fetsel("mime_type", "spip_types_documents", "extension=".sql_quote(strtolower($p['typedoc'])));
			if ($row)
				$type = '&type='.$row['mime_type'];
		} elseif ($getdoc) {
				if ($typesdoc = cisquel_config('cisquelmnotypesdocuments')) {
					if (is_array($typesdoc)) {
						$in = sql_in('extension',$typesdoc);		
						$result = sql_select("mime_type","spip_types_documents",$in);
						while ($row = sql_fetch($result))
							$type .= '&type='.$row['mime_type'];
					}
				}
				$qs['ps'] = 10;
		}		
	}

	// liaison
	$urlmoteur = cisquel_url_moteur();
	if (strpos($urlmoteur,'?')===false)
		$urlmoteur .= '?';
	else
		$urlmoteur .= '&';
			
	
	$url = $urlmoteur
	.'avancee='.$qs['avancee']
	.'&s='.$s1
	.'&ps='.$qs['ps']
	.'&cat='.$qs['cat']
	.'&ul='.$ul
	.'&wf='.$qs['wf']
	.'&ftm='.$qs['ftm']
	.'&GroupBySite='.$groupbysite
	.'&tl='.$qs['tl']
	.'&categorie='.$qs['categorie']
	.'&q='.$recherche
	.'&m='.$qs['m']
	.'&categ='.$categ
	.'&site='.$site
	.'&fmt='.$qs['fmt']
	.'&s='.$s2
	.'&GroupBySite='.$groupbysite
	.'&wf='.$qs['wf']
	.$type
	.'&dp='.$qs['dp']
	.'&dt='.$qs['dt']
	.'&ps='.$qs['ps']
	.$db
	.$de;
	
	return $url;
}

function cisquel_url_recherche_google($p=array(), $touslessites=false) {

	// liaison
	$urlmoteur = cisquel_url_moteur();
	if (strpos($urlmoteur,'?')===false)
		$urlmoteur .= '?';
	else
		$urlmoteur .= '&';
	

	// tenir compte des options de recherche
	// et les convertir au format attentdu par google
	$options = '';
	
	if ($p) {
		// urlencode remplace au passage les espaces par le signe plus
		// urlencode n'est pas unicode
		if ($GLOBALS['meta']['charset']=='utf-8')
			$recherche = urlencode(utf8_decode($p['recherche']));
		else
			$recherche = urlencode($p['recherche']);

		// a mettre en premier
		if ($p['typedoc'])
			$options .= '+filetype:'.$p['typedoc'];

		if ($p['age'])
			$options .= '&as_qdr=d'.$p['age'];

		if ($p['datedebut'] AND $p['datefin']) {
			$options .= '&tbs=cdr:1,cd_min:'.$p['datedebut'].',cd_max:'.$p['datefin'];
			if ($p['tri']=='datedesc' OR $p['tri']=='date')
				$options .= ',sbd:1';
		} else {
			if ($p['tri']=='datedesc' OR $p['tri']=='date')
				$options .= '&tbs=cdr:1,sbd:1';
			
		}				
	}

	if ($touslessites) {
		$url = $urlmoteur.'q='.$recherche.$options;
	
		// lire la configuration du plugin
		$tableau_config = cisquel_lire_meta();
		if ($domainetoussites = urlencode($tableau_config['cisqueldomainetoussites']))
			$url .= '&as_sitesearch='.$domainetoussites;

	} else {
		$url = $urlmoteur.'q='.$recherche.$options.'&as_sitesearch='.urlencode($GLOBALS['meta']['adresse_site']);
	}

	return $url;
}

/**
 * Filtre de redirection
 *
 * @param : $recherche (via la securite de SPIP)
 *			$env (qui necessite un #ENV sans filtre, sachant que la securite est assuree apres par cisquel_verifier_parametres)
 * @return : rien
 */
function cisquel_redirige($recherche, $env) {
	
	// indispensable (necessite un #ENV sans filtre)
	$unenv = unserialize($env);
	
	// securite
	$p = cisquel_verifier_parametres($unenv);


	if ($p['recherche'] AND $p['elargir']) {

		if (cisquel_choixelargirrecherche()=='oui') {
		
			// lire la configuration du plugin
			$tableau_config = cisquel_lire_meta();
			$cisquelgetmnosite = $tableau_config['cisquelgetmnosite'];
			$cisquelgetmnotoussites = $tableau_config['cisquelgetmnotoussites'];	
			$cisquelchoixrecherchetouslessites = $tableau_config['cisquelchoixrecherchetouslessites'];
                        $protocol = 'http://';
                        if (isset($tableau_config['cisquelmoteurhttps']) AND strtolower($tableau_config['cisquelmoteurhttps'])=='oui'){
                            $protocol = 'https://';
                        }
                        
			if ($p['elargir']=='toussites' AND $cisquelchoixrecherchetouslessites=='oui')
				$toussites = true;
			else
				$toussites = false;
		
			$url = '';	
			$moteur = cisquel_moteur();	
			if ($moteur=='mnogosearch') {
				if (($p['elargir']=='doc' AND $cisquelgetmnosite!='oui') OR ($p['elargir']=='toussites' AND $cisquelgetmnotoussites!='oui')) {
					$url = $protocol.cisquel_url_recherche_mno($p, $toussites);
				}
			} elseif ($moteur=='google') {
				$url = $protocol.cisquel_url_recherche_google($p, $toussites);
			}
	
			if ($url) {
				include_spip('inc/headers');
				redirige_par_entete($url);
			}
		}
	}

	return '';
}


function cisquel_getmnochoix($recherche, $env) {

	// lire la configuration du plugin
	$tableau_config = cisquel_lire_meta();
	$cisquelgetmnosite = $tableau_config['cisquelgetmnosite'];
	$cisquelgetmnotoussites = $tableau_config['cisquelgetmnotoussites'];	
	
	// indispensable (necessite un #ENV sans filtre)
	$unenv = unserialize($env);
	
	// securite
	$p = cisquel_verifier_parametres($unenv);
	
	if ($p['elargir']=='toussites' AND $cisquelgetmnotoussites=='oui')
		$return = 'toussites';
	elseif ($p['elargir']=='doc' AND $cisquelgetmnosite=='oui')
		$return = 'doc';
	else
		$return = '';

	return $return;
}

?>