<?php
/**
 * Plugin CISTYLE
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/cistyle_commun');


function formulaires_cistyle_config_couleur_charger_dist($page_retour='') {

	if (!autoriser('configurer', 'configuration')){
		return false;
        }
        
        if (cistyle_palette($page_retour)!=1){
		return false;
        }
        
	// valeurs actuelles
	$valeurs = cistyle_tableau_couleurs($page_retour);

        // compatibilite
        if (!$page_retour AND defined('_DIR_PLUGIN_CIBLOC')){
            $page_retour = 'configurer_cibloc';
        }
        
        $valeurs['page_retour'] = $page_retour;
        
	return $valeurs;
}

function formulaires_cistyle_config_couleur_verifier_dist($page_retour=''){
        $erreurs = array();
        $tableau_couleurs = cistyle_tableau_nom_des_couleurs();
        
        foreach ($tableau_couleurs AS $couleur){
            if ($valeur_saisie = _request($couleur)){
                if (!cistyle_verifier_couleur_hexa($valeur_saisie)){
                    $erreurs[$couleur] =  _T('cistyle:valeur_incorrecte');
                }
            }
        }

	return $erreurs;
}

function formulaires_cistyle_config_couleur_traiter_dist($page_retour=''){
	
	$valeurs_actuelles = cistyle_tableau_couleurs();
	$ok = false;	
        $res = array();
        $valeurs_futures = array();
        $tableau_couleurs = cistyle_tableau_nom_des_couleurs();
        
        foreach ($tableau_couleurs AS $couleur){
            if ($valeur_saisie = _request($couleur)){
                if (cistyle_verifier_couleur_hexa($valeur_saisie)){
                    if ($valeur_saisie != $valeurs_actuelles[$couleur]){
                        $valeurs_actuelles[$couleur] = $valeur_saisie;
                        $ok = true;
                    }
                }
            }
        }

	if ($ok){                
                $nom = 'couleur';
                $valeurs_futures['valeur'] = serialize($valeurs_actuelles);
            
                $row = sql_fetsel('*', "spip_cistyle_config","nom='".$nom."'");
                if ($row) {
                        sql_updateq("spip_cistyle_config", $valeurs_futures, "nom='".$nom."'");
                } else {
                        $valeurs_futures['nom'] = $nom;
                        sql_insertq('spip_cistyle_config', $valeurs_futures);
                }
                
                if (defined('_DIR_PLUGIN_CIBLOC')) {
                    include_spip('inc/cibloc_commun');
                    include_spip('inc/invalideur');
                    suivre_invalideur("1");
                    cibloc_purger_cache_css();
                }
        }
        
	$res['message_ok'] = "";
	$res['redirect'] = "";
	
	return $res;	
}

?>