<?php
/**
 * Plugin CISTYLE
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;


function cistyle_tableau_couleurs($page_retour='') {
//    static $done = false;
    static $tableau_couleurs = array();
    
    if ($page_retour){
        $index = $page_retour;
    } else {
        $index = 'defaut';
    }
    

    if (!isset($tableau_couleurs[$index])){
        $return = array();
        $palette = cistyle_palette($page_retour);

        // palette personnalisee
        if ($palette==1){
            // valeurs par defaut
            $return = cistyle_tableau_couleurs_par_defaut();

            // le parametrage par constante est prioritaire
            $tableau_par_constante = cistyle_contenu_du_parametrage_par_constante('couleur',$page_retour);

            if ($tableau_par_constante) {
                $return = unserialize($tableau_par_constante[0]['valeur']);

            } else {
                // config personnalisee
                $row = sql_fetsel('valeur', "spip_cistyle_config","nom='couleur'");
                if ($row){
                    if ($row['valeur']){
                        $return = unserialize($row['valeur']);
                    }
                }
            }

        } else {
            $tableau_couleurs_palettes = cistyle_tableau_couleurs_palettes();
            if (isset($tableau_couleurs_palettes[$palette])){
                $return = $tableau_couleurs_palettes[$palette];
            }
        }
        
        $tableau_couleurs[$index] = $return;
    }
    
    return $tableau_couleurs[$index];
}


function cistyle_palette($page_retour='') {
    static $num_palette=array();
    
    if ($page_retour){
        $index = $page_retour;
    } else {
        $index = 'defaut';
    }
    
    if (!isset($num_palette[$index])){
        // valeur par defaut
        $return = 2;
        
        // le parametrage par constante est prioritaire
        $tableau_par_constante = cistyle_contenu_du_parametrage_par_constante('palette',$page_retour);

        if ($tableau_par_constante) {
            // valeur 1 pour la palette personnalisee et qui peut etre imposee
            $return = $tableau_par_constante[0]['valeur'];

        } elseif (!cistyle_imposer_parametrage('palette')) {
            // config personnalisee
            $row = sql_fetsel('valeur', "spip_cistyle_config","nom='palette'");
            if ($row){
                if ($row['valeur']){
                    $return = $row['valeur'];
                }
            }
        }
        
        $num_palette[$index] = $return;
    }
    
    return $num_palette[$index];
}



function cistyle_verifier_couleur_hexa($couleur){
    $return = false;
    if (preg_match(',^#[a-f0-9]{6}$,i', $couleur)){
        $return = true;
    }
    
    return $return;
}


function cistyle_tableau_nom_des_couleurs(){
    return array(
        'blanc',
        'gris1','gris2','gris3','gris4','gris5','gris6',
        'noir1','noir2','noir3',
        'couleur1','couleur2','couleur3','couleur4','couleur5',
        'couleur6','couleur7','couleur8','couleur9','couleur10'
        );
}


function cistyle_tableau_couleurs_par_defaut(){
    $return = array();
    
    $return['blanc'] = '#FFFFFF';
    
    $return['gris1'] = '#efefef';
    $return['gris2'] = '#e2e2e2';
    $return['gris3'] = '#cdcdcd';
    $return['gris4'] = '#bfbfbf';
    $return['gris5'] = '#767676';
    $return['gris6'] = '#656565';
    
    $return['noir1'] = '#484848';
    $return['noir2'] = '#202328';
    $return['noir3'] = '#000000';

    $return['couleur1'] = '#5B443B';
    $return['couleur2'] = '#BF9C80';
    $return['couleur3'] = '#EFDEC2';
    $return['couleur4'] = '#DF9467';
    $return['couleur5'] = '#F1E3D6';
    $return['couleur6'] = '#FFFFFF';
    $return['couleur7'] = '#FFFFFF';
    $return['couleur8'] = '#FFFFFF';
    $return['couleur9'] = '#FFFFFF';
    $return['couleur10'] = '#FFFFFF';
    
    return $return;
}


function cistyle_tableau_couleurs_palettes(){
	static $couleurs_palettes = array(
		2 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#5B443B","couleur2" => "#BF9C80","couleur3" => "#EFDEC2","couleur4" => "#DF9467","couleur5" => "#F1E3D6",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		3 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#665130","couleur2" => "#CDA261","couleur3" => "#FFDDAA","couleur4" => "#ffeed5","couleur5" => "#fff7ea",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		4 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#7d4d00","couleur2" => "#fa9a00","couleur3" => "#ffc000","couleur4" => "#ffe080","couleur5" => "#ffefbf",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		5 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#6f2221","couleur2" => "#DF4543","couleur3" => "#FAACB0","couleur4" => "#fdd6d8","couleur5" => "#feeaeb",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		6 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#6a0d30","couleur2" => "#D51B60","couleur3" => "#EF91B4","couleur4" => "#f7c8da","couleur5" => "#fbe4ec",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		7 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#4c4c33","couleur2" => "#999966","couleur3" => "#CCCC99","couleur4" => "#e6e6cc","couleur5" => "#f2f2e6",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		8 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#4e5d00","couleur2" => "#9DBA00","couleur3" => "#C5E41C","couleur4" => "#e2f28e","couleur5" => "#f1f8c6",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		9 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#2e5362","couleur2" => "#5da7c5","couleur3" => "#97d2e1","couleur4" => "#cbe9f0","couleur5" => "#e5f4f8",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		10 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#47475e","couleur2" => "#8F8FBD","couleur3" => "#C4C4DD","couleur4" => "#e2e2ee","couleur5" => "#f0f0f7",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		11 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#42484d","couleur2" => "#85909A","couleur3" => "#C0CAD4","couleur4" => "#e0e5ea","couleur5" => "#eff2f4",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
		12 => array(
                        "blanc" => "#FFFFFF",
                        "gris1" => "#efefef","gris2" => "#e2e2e2","gris3" => "#cdcdcd","gris4" => "#bfbfbf","gris5" => "#767676","gris6" => "#656565",
                        "noir1" => "#484848","noir2" => "#202328","noir3" => "#000000",
                        "couleur1" => "#484848","couleur2" => "#909090","couleur3" => "#D3D3D3","couleur4" => "#e9e9e9","couleur5" => "#f4f4f4",
                        "couleur6" => "#ffffff","couleur7" => "#ffffff","couleur8" => "#ffffff","couleur9" => "#ffffff","couleur10" => "#ffffff"
		),
	);
    
        return $couleurs_palettes;
}

function cistyle_imposer_parametrage($valeur=''){
    $return = false;

    $valeurs_possibles = array(
            'couleur',
            'palette',
            'style',
            'styles'
            );

    if (in_array($valeur,$valeurs_possibles)){
        if (defined('_CISTYLE_'.strtoupper($valeur))){
            $return = true;
        }
    }

    if (!$return AND defined('_DIR_PLUGIN_CIBLOC')) {
        include_spip('inc/cibloc_commun');
        if (cibloc_imposer_parametrage($valeur)){
            $return = true;
        }
    }
    
    if (!$return AND defined('_DIR_PLUGIN_CIWIDGET')) {
        include_spip('inc/ciwidget_inc_meta');
        if (in_array($valeur,array('couleur','palette')) AND ciwidget_parametrage_couleur_par_fichier()){
            $return = true;
        } elseif ($valeur=='styles' AND ciwidget_parametrage_styles_par_fichier()){
            $return = true;
        }
    }
    
    return $return;
}



function cistyle_parametrage_couleur_par_constante($arg=''){
    $return = array();
    $noms_et_codes = array();
    $tableau = array();
    
    // parametrage par constante dans un fichier d'options
    // syntaxe define('_CISTYLE_NOMS_ET_CODES_COULEUR','gris1=#efefef,gris2=#e2e2e2,gris3=#cdcdcd,...');
    if (defined('_CISTYLE_NOMS_ET_CODES_COULEUR') AND _CISTYLE_NOMS_ET_CODES_COULEUR) {
        if (ctype_alnum(str_replace(array('=','#',','),'',_CISTYLE_NOMS_ET_CODES_COULEUR)) ){
            $noms_et_codes = explode(',', _CISTYLE_NOMS_ET_CODES_COULEUR);

            if ($noms_et_codes){
                foreach ($noms_et_codes AS $nom_et_code){
                    $tableau = explode('=',trim($nom_et_code));
                    if ($tableau){
                        $return[trim($tableau[0])] = trim($tableau[1]);
                    }
                }
            }
        }
    }
        
    return $return;
}


function cistyle_tableau_style() {
    $return = array();

    // valeurs par defaut
    $return = cistyle_tableau_style_par_defaut();
    
    // le parametrage par constante est prioritaire
    $tableau_par_constante = cistyle_contenu_du_parametrage_par_constante('style');
    if ($tableau_par_constante) {
        $return = unserialize($tableau_par_constante[0]['valeur']);

    } elseif (!cistyle_imposer_parametrage('style')) {
        // config personnalisee
        $row = sql_fetsel('valeur', "spip_cistyle_config","nom='style'");
        if ($row){
            if ($row['valeur']){
                $return = unserialize($row['valeur']);
            }
        }
    }
        
    return $return;
}

function cistyle_tableau_styles() {
    $return = array();

    // le parametrage par constante est prioritaire
    $tableau_par_constante = cistyle_contenu_du_parametrage_par_constante('styles');
    if ($tableau_par_constante) {
        $return = $tableau_par_constante;
    } else {
        $return = sql_allfetsel('id_style,nom,valeur,statut,rang', 'spip_cistyle_styles', '', '', 'id_style');
    }

    return $return;
}

function cistyle_tableau_styles_selection($tableau_ids_style=array()) {
    $return = array();

    $tableau_styles = cistyle_tableau_styles();

    foreach ($tableau_styles as $cle => $valeur) {
        if (in_array($valeur['id_style'], $tableau_ids_style)){
            $return[] = $valeur;
        }
    }
    
    return $return;
}

function cistyle_tableau_nom_des_styles(){
    return array(
'body_font-family',
'body_font-size',
'body_color',
'body_line-height',
'body_text-align',
'p_margin',
'intertitre_font-size',
'intertitre_font-weight',
'intertitre_color',
'intertitre_padding',
'intertitre_margin'
        );
}


function cistyle_tableau_style_par_defaut(){
    $return = array();
    
    $return['body_font-family'] = 'Verdana, Geneva, Arial, Helvetica, sans-serif';
    $return['body_font-size'] = '0.7rem';
    $return['body_color'] = '#484848';
    $return['body_line-height'] = '0.8rem';
    $return['body_text-align'] = 'justify';
    $return['p_margin'] = '0px 0px 15px 0px';
    $return['intertitre_font-size'] = '0.9rem';
    $return['intertitre_font-weight'] = 'bold';
    $return['intertitre_color'] = '#484848';
    $return['intertitre_padding'] = '0.7rem 0px 0.2rem 0px';
    $return['intertitre_margin'] = '0px 0px 0.2rem';
   
    return $return;
}


function cistyle_tableau_nom_des_proprietes(){
    return array(
'font-family',
'font-size',
'font-sizeem',
'font-weight',
'font-style',
'line-height',
'line-heightem',
'text-align',
'text-decoration',
'text-indent',
'text-shadow',
'text-transform',
'vertical-align',
'white-space',
'word-wrap',
'color',
'colorhexa',
'background-color',
'background-colorhexa',
'background-colorhover',
'background-coloractive',
'background-colorhexahover',
'background-colorhexaactive',
'background-attachment',
'background-repeat',
'background-position',
'opacity',
'width',
'height',
'min-width',
'max-width',
'min-height',
'max-height',
'margin-top',
'margin-right',
'margin-bottom',
'margin-left',
'margin',
'padding-top',
'padding-right',
'padding-bottom',
'padding-left',
'padding',
'border-style',
'border-top-style',
'border-right-style',
'border-left-style',
'border-bottom-style',
'border-color',
'border-colorhexa',
'border-width',
'border-top-width',
'border-bottom-width',
'border-right-width',
'border-left-width',
'border-radius',
'box-shadow',
'content',
'contentafter',
'mask-image',
'icon-size',
'display',
'align-items'
        );
}


function cistyle_contenu_du_parametrage_par_constante($valeur='',$page_retour=''){
    static $tableau = array();
    static $done = array();
    $return = array();
    
    if (!isset($done[$valeur.$page_retour])){
        $valeurs_possibles = array(
                'couleur',
                'palette',
                'style',
                'styles'
                );

        if (in_array($valeur,$valeurs_possibles)){
            // forcer la priorite
            if ($page_retour=='configurer_ciwidget' 
                    AND defined('_DIR_PLUGIN_CIWIDGET')
                    AND ($valeur=='couleur' OR $valeur=='palette')
                    ){
                include_spip('inc/ciwidget_inc_meta');
                $param_ciwidget = ciwidget_contenu_du_parametrage_par_constante($valeur);
                
                // charger le fichier de parametrage avant
                if (defined('_CIWIDGET_COULEUR_PRIORITAIRE') AND _CIWIDGET_COULEUR_PRIORITAIRE=='oui') {
                    $return = $param_ciwidget;
                    
                    if (!$return){
                        $constante_ciwidget = '_CIWIDGET_'.strtoupper($valeur);
                        if (defined($constante_ciwidget)){
                            $return = cistyle_valeur_par_defaut($valeur);
                        }
                    }
                }
            } 
            
            if (!$return){
                // parametrage par fichier
                $f = _DIR_ETC . '_config_cistyle.php';
                if (@file_exists($f)) {
                        include_once($f);
                }
                $constante_cistyle = '_CISTYLE_'.strtoupper($valeur);

                if (defined($constante_cistyle)){
                    $return = unserialize(base64_decode(constant($constante_cistyle)));
                }
            }
            if (!$return AND defined('_DIR_PLUGIN_CIBLOC')){
                include_spip('inc/cibloc_commun');
                $return = cibloc_contenu_du_parametrage_par_constante($valeur);
                
                if (!$return){
                    $constante_cibloc = '_CIBLOC_'.strtoupper($valeur);
                    if (defined($constante_cibloc)){
                        $return = cistyle_valeur_par_defaut($valeur);
                    }
                }
            }
            if (!$return AND defined('_DIR_PLUGIN_CIWIDGET')){
                include_spip('inc/ciwidget_inc_meta');
                $return = ciwidget_contenu_du_parametrage_par_constante($valeur);
            } 
        }
        $done[$valeur.$page_retour] = 'oui';
        $tableau[$valeur.$page_retour] = $return;
    }
    
    if (!$return AND isset($tableau[$valeur.$page_retour])){
        $return = $tableau[$valeur.$page_retour];
    }
    
    return $return;
}

function cistyle_valeur_par_defaut($valeur){
    $return = array();
    
    if ($valeur=='couleur'){
        $return = array(array('nom'=>$valeur, 'valeur'=>serialize(cistyle_tableau_couleurs_par_defaut())));
    } elseif ($valeur=='palette'){
        $return = array(array('nom'=>$valeur, 'valeur'=>serialize("2")));
    } elseif ($valeur=='style'){
        $return = array(array('nom'=>$valeur, 'valeur'=>serialize(cistyle_tableau_style_par_defaut())));
    }
    return $return;
}

function cistyle_verifier($attribut,$valeur){
    $return = false;
    $valeur = trim($valeur);
    
    switch($attribut) {
        case 'font-family':
                if (ctype_alnum(str_replace(array(',','-',' ','"',"'"),'',$valeur))){
                    $return = true;
                }
                break;
        case 'font-size':
                if (cistyle_verifier_taille_avec_unite($valeur,1)){
                    $return = true;
                }
                break;
        case 'color':
                if (preg_match(',^#[a-f0-9]{6}$,i', $valeur)){
                    $return = true;
                }
                break;
        case 'line-height':
                if (cistyle_verifier_taille_avec_unite($valeur,1)){
                    $return = true;
                }
                break;
        case 'text-align':
                if (in_array($valeur,array('left','center','right','justify'))){
                    $return = true;
                }
                break;
        case 'font-weight':
                if (in_array($valeur,array('normal','bold','bolder','lighter','100','200','300','400','500','600','700','800','900','inherit','initial','unset'))){
                    $return = true;
                }
                break;
        case 'padding':
                if (cistyle_verifier_taille_avec_unite($valeur,4)){
                    $return = true;
                }
                break;
        case 'margin':
                if (cistyle_verifier_taille_avec_unite($valeur,4)){
                    $return = true;
                }
                break;
    }

    return $return;
}

function cistyle_verifier_taille_avec_unite($texte,$max){
    $return = false;
    $unites = array('em','rem','%','px','ex','cm','mm','in','pt','pc');
    $texte = trim($texte);
    $size_ok = false;
    $tableau_ok = true;

    if (empty($texte)){
        return true;    
    }
    $tableau = explode(' ',$texte);
    
    if (count($tableau)<=intval($max)){
        
        foreach ($tableau as $valeur) {
            $size_ok = false;
            $valeur = trim($valeur);
            $size = floatval($valeur);
            $unite = str_replace($size,'',$valeur);
            
            // cas particulier : 1.0 au lieu de 1
            if (substr($unite,0,2)=='.0'){
                $unite = substr($unite,2);
            }
            
            if ($size!=0){
                $size_ok = true;
            } elseif ($size==0 AND substr($valeur,0,1)=='0'){
                $size_ok = true;
            }

            if (!$size_ok OR ($unite AND !in_array($unite,$unites))){
                $tableau_ok = false;
            }
        }
        
        if ($tableau_ok){
            $return = true;
        }
    }
    
    return $return;
}

function cistyle_verifier_taille_em($texte,$max){
    $return = false;
    $unites = array('em');
    $texte = trim($texte);
    $size_ok = false;
    $tableau_ok = true;

    if (empty($texte)){
        return true;    
    }
    $tableau = explode(' ',$texte);
    
    if (count($tableau)<=intval($max)){
        
        foreach ($tableau as $valeur) {
            $size_ok = false;
            $valeur = trim($valeur);
            $size = floatval($valeur);
            $unite = str_replace($size,'',$valeur);
            
            // cas particulier : 1.0 au lieu de 1
            if (substr($unite,0,2)=='.0'){
                $unite = substr($unite,2);
            }
            
            if ($size!=0){
                $size_ok = true;
            } elseif ($size==0 AND substr($valeur,0,1)=='0'){
                $size_ok = true;
            }

            if (!$size_ok OR ($unite AND !in_array($unite,$unites))){
                $tableau_ok = false;
            }
        }
        
        if ($tableau_ok){
            $return = true;
        }
    }
    
    return $return;
}

function cistyle_choix_weight($champ='',$valeur_champ='',$disabled=''){
    $return = '';
    $selected = '';
    
    if ($disabled){
        $disabled = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('','normal','bold','bolder','lighter','100','200','300','400','500','600','700','800','900','inherit','initial','unset');
    // Parcours du tableau
    $return .= '<select name="'.$champ.'" '.$disabled.'>'."\n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_champ){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function cistyle_choix_fontstyle($champ='',$valeur_champ='',$disabled=''){
    $return = '';
    $selected = '';
    
    if ($disabled){
        $disabled = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('','normal','italic','inherit','initial','unset');
    // Parcours du tableau
    $return .= '<select name="'.$champ.'" '.$disabled.'>'."\n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_champ){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function cistyle_choix_align($champ='',$valeur_champ='',$disabled=''){
    $return = '';
    $selected = '';

    if ($disabled){
        $disabled = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('','left','center','right','justify');
    // Parcours du tableau
    $return .= '<select name="'.$champ.'" '.$disabled.'>'."n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_champ){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function cistyle_choix_align_items($champ='',$valeur_champ='',$disabled=''){
    $return = '';
    $selected = '';

    if ($disabled){
        $disabled = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('','center','start','end');
    // Parcours du tableau
    $return .= '<select name="'.$champ.'" '.$disabled.'>'."n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_champ){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function cistyle_choix_display($champ='',$valeur_champ='',$disabled=''){
    $return = '';
    $selected = '';

    if ($disabled){
        $disabled = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('','inline','inline-block','block');
    // Parcours du tableau
    $return .= '<select name="'.$champ.'" '.$disabled.'>'."n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_champ){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function cistyle_choix_bordure($champ='',$valeur_champ='',$disabled=''){
    $return = '';
    $selected = '';

    if ($disabled){
        $disabled = 'disabled="disabled"';
    }
    
    if (!$valeur_champ){
        $valeur_champ = 'non';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array(''=>'','none'=>'aucune bordure','solid'=>'trait');
    // Parcours du tableau
    $return .= '<select name="'.$champ.'" '.$disabled.'>';
    foreach($tableau_valeurs as $cle=>$valeur){
        
        if($cle == $valeur_champ){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $cle .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function cistyle_choix_couleur($champ='',$couleur_selected='',$disabled = ''){
    if ($disabled){
        $disabled_texte = 'disabled="disabled"';
    }
    return cistyle_choix_couleur_commun($champ,$couleur_selected,true,false,$disabled);
}

function cistyle_choix_couleur_commun($champ='',$couleur_selected='',$transparent=false,$transparent_desactive=false,$disabled=''){
    $return = '';
    $selected = '';

    // tableau des couleurs
    $tableau_couleurs = cistyle_tableau_couleurs();
    
    if ($transparent){
        $tableau_couleurs = array_merge(array('transparent'=>''),$tableau_couleurs);
    }

    $type_couleur = 'tout';

    if ($couleur_selected AND isset($tableau_couleurs[$couleur_selected])){
        if (cistyle_couleur_texte_pour_contraster($tableau_couleurs[$couleur_selected])){
            $style_selected = ' style="background-color:'.$tableau_couleurs[$couleur_selected].';color:#FFFFFF;"';
        } else {   
            $style_selected = ' style="background-color:'.$tableau_couleurs[$couleur_selected].';color:#484848;"';
        }    
    } else {
        $style_selected = '';
    }
    // Parcours du tableau
    $return .= '<select name="'.$champ.'" onchange="cistyle_change_style_select(this)"'.$style_selected.$disabled.'>'."n";
    foreach($tableau_couleurs as $nom_couleur => $valeur_hexa){
        if ($type_couleur=='tout' OR strpos($nom_couleur,$type_couleur)!== false){
            if($nom_couleur === $couleur_selected){
                $selected = ' selected="selected"';
            } else {
                $selected = '';
            }

            if ($nom_couleur=='transparent'){
                $style = ' style="background-color:#FFFFFF;color:#484848;"';
            } elseif (cistyle_couleur_texte_pour_contraster($valeur_hexa)){
                $style = ' style="background-color:'.$valeur_hexa.';color:#FFFFFF;"';
            } else {
                $style = ' style="background-color:'.$valeur_hexa.';color:#484848;"';
            }
            
            if ($transparent_desactive AND $nom_couleur=='transparent'){
                $libelle_couleur = _T('cistyle:desactive_couleur');
            } else {
                $libelle_couleur = $nom_couleur;
            }

            // Affichage de la ligne
            $return .= "\t".'<option value="'. $nom_couleur .'"'. $selected . $style .'>'. $libelle_couleur .'</option>'."\n";
        }
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function cistyle_couleur_texte_pour_contraster($couleur_fond_hexa=''){
    $return = '';
    
    if ($couleur_fond_hexa AND preg_match(',^#[a-f0-9]{6}$,i', $couleur_fond_hexa)){
        list($r, $g, $b) = sscanf($couleur_fond_hexa, "#%02x%02x%02x");
        $valeur = (($r * 299) + ($g * 587) + ($b * 114)) / 1000;
        if ( $valeur < 125 ){
            $return = '#FFFFFF';
        } elseif ( $valeur < 150 ){
            $return = '#000000';
        } elseif ( $valeur < 160 ){
            $return = '#080808';
        } elseif ( $valeur < 180 ){
            $return = '#181818';
        }
    }
    
    return $return;
}

function cistyle_lire_style($id_style=''){
    $return = array();
    
    if ($id_style){
        // le parametrage par constante est prioritaire
        $tableau_par_constante = cistyle_contenu_du_parametrage_par_constante('styles');
        if ($tableau_par_constante) {
            foreach ($tableau_par_constante as $style) {
                if (isset($style['id_style']) AND $style['id_style']==$id_style){
                    $return = unserialize($style['valeur']);
                }
            }
        } else {
            $row = sql_fetsel('*', 'spip_cistyle_styles', "id_style='" . $id_style . "'");
            if ($row){
                $return = unserialize($row['valeur']);
            }
        }
    }
    
    return $return;
}

function cistyle_verifier_propriete($propriete,$valeur,$couleur_hexa=false){
    $return = false;
    $valeur = trim($valeur);
    
    switch($propriete) {
        case 'font-family':
                if (!$valeur OR ctype_alnum(str_replace(array(',','-',' ','"',"'"),'',$valeur))){
                    $return = true;
                }
                break;
        case 'font-size':
        case 'icon-size':
                if (cistyle_verifier_taille_avec_unite($valeur,1)){
                    $return = true;
                }
                break;
        case 'font-sizeem':
                if (cistyle_verifier_taille_em($valeur,1)){
                    $return = true;
                }
                break;
        case 'font-weight':
                if (!$valeur OR in_array($valeur,array('normal','bold','bolder','lighter','100','200','300','400','500','600','700','800','900','inherit','initial','unset'))){
                    $return = true;
                }
                break;
        case 'font-style':
                if (!$valeur OR in_array($valeur,array('normal','italic','inherit','initial','unset'))){
                    $return = true;
                }
                break;
        case 'text-align':
                if (!$valeur OR in_array($valeur,array('left','center','right','justify'))){
                    $return = true;
                }
                break;
        case 'text-decoration':
                if (!$valeur OR ctype_alnum(str_replace(array(' ','#','-','.',',','(',')'),'',$valeur))){
                    $return = true;
                }
                break;
        case 'text-indent':
                if (!$valeur OR ctype_alnum(str_replace(array(' ','.','-','%') ,'',$valeur))){
                    $return = true;
                }
                break;
        case 'text-shadow':
        case 'box-shadow':
                if (!$valeur OR ctype_alnum(str_replace(array(' ','-','%','#','.',',','(',')') ,'',$valeur))){
                    $return = true;
                }
                break;
        case 'text-transform':
                if (!$valeur OR ctype_alpha(str_replace(array('-'),'',$valeur))){
                    $return = true;
                }
                break;
        case 'vertical-align':
                if (!$valeur OR ctype_alnum(str_replace(array('-','%','.'),'',$valeur))){
                    $return = true;
                }
                break;
        case 'display':
                if (!$valeur OR in_array($valeur,array('','block','inline-block','inline','initial'))){
                    $return = true;
                }
                break;
        case 'align-items':
                if (!$valeur OR in_array($valeur,array('','center','start','end'))){
                    $return = true;
                }
                break;
        case 'color':
        case 'background-color':
        case 'background-colorhover':
        case 'background-coloractive':
        case 'border-color':
                if (!$couleur_hexa){
                    // tableau des couleurs
                    $nom_couleurs = array_keys(cistyle_tableau_couleurs());
                    $nom_couleurs[] = 'transparent';
                    if (in_array($valeur,$nom_couleurs)){
                        $return = true;
                    }
                } else {
                    if (!$valeur OR preg_match(',^#[a-f0-9]{6}$,i', $valeur)){
                        $return = true;
                    }
                }
                break;
        case 'colorhexa':
        case 'background-colorhexa':
        case 'background-colorhexahover':
        case 'background-colorhexaactive':
        case 'border-colorhexa':
                if (!$valeur OR preg_match(',^#[a-f0-9]{6}$,i', $valeur)){
                    $return = true;
                }
                break;
        case 'background-attachment':
                if (!$valeur OR in_array($valeur,array('scroll','fixed','local','inherit','initial','revert','unset'))){
                    $return = true;
                }
                break;
        case 'background-repeat':
                if (!$valeur OR ctype_alpha(str_replace(array('-',' '),'',$valeur))){
                    $return = true;
                }
                break;
        case 'background-position':
                if (!$valeur OR ctype_alnum(str_replace(array(' ','.','%') ,'',$valeur))){
                    $return = true;
                }
                break;
        case 'opacity':
                if (!$valeur OR ctype_alnum(str_replace(array('.') ,'',$valeur))){
                    $return = true;
                }
                break;
        case 'height':
        case 'min-height':
        case 'max-height':
        case 'width':
        case 'min-width':
        case 'max-width':
        case 'line-height':
                if (!$valeur OR cistyle_verifier_taille_avec_unite($valeur,1)){
                    $return = true;
                }
                break;
        case 'line-heightem':
                if (cistyle_verifier_taille_em($valeur,1)){
                    $return = true;
                }
                break;
        case 'padding':
        case 'margin':
                if (!$valeur OR cistyle_verifier_taille_avec_unite($valeur,4)){
                    $return = true;
                }
                break;
        case 'padding-top':
        case 'padding-bottom':
        case 'padding-right':
        case 'padding-left':
        case 'margin-top':
        case 'margin-bottom':
        case 'margin-right':
        case 'margin-left':
        case 'border-top-width':
        case 'border-bottom-width':
        case 'border-right-width':
        case 'border-left-width':
                if (!$valeur OR cistyle_verifier_taille_avec_unite($valeur,1)){
                    $return = true;
                }
                break;
        case 'border-style':
        case 'border-top-style':
        case 'border-right-style':
        case 'border-left-style':
        case 'border-bottom-style':
                if (!$valeur OR in_array($valeur,array('none','solid'))){
                    $return = true;
                }
                break;
        case 'border-width':
                if (!$valeur OR cistyle_verifier_taille_avec_unite($valeur,4)){
                    $return = true;
                }
                break;
        case 'border-radius':
                if (!$valeur OR cistyle_verifier_taille_avec_unite($valeur,1)){
                    $return = true;
                }
                break;
        case 'content':
        case 'contentafter':
                if (!$valeur OR ctype_alnum(str_replace(array(' ','-','_','#','.',',','(',')',' :','/','\\') ,'',$valeur))){
                    $return = true;
                }
                break;
        case 'mask-image':
                if (!$valeur OR preg_match(",<svg\b[^>]*>,UimsS", $valeur)){
                    include_spip('inc/texte');
                    if ($valeur == echappe_js($valeur)){
                        $return = true;
                    }
                }
                break;
    }

    return $return;
}

function cistyle_style_editer($id_style='',$plugin='',$objet='',$element='',$c=array()){
    $return = '';
    $champs = array();
    
    $champs['nom'] = $plugin.' '.$objet.' '.$element;
    if ($c){
        $champs['valeur'] = serialize($c);
    } else {
        $champs['valeur'] = serialize(array());
    }
    
    if ($id_style AND $c AND $row=sql_fetsel('*', 'spip_cistyle_styles', "id_style='" . $id_style . "'")){
            sql_updateq("spip_cistyle_styles", $champs, "id_style='" . $id_style . "'");
            $return = $id_style;
    } else {
            // ATTENTION : pour la compatibilité avec l'import / export de configuration
            // id_style n'est volontairement pas la clé primaire afin de ne pas être auto incrémenté.
            $champs['id_style'] = $plugin.'_'.$objet.'_'.$element;
            $id_auto = sql_insertq('spip_cistyle_styles', $champs);
            if ($id_auto){
                $return = $champs['id_style'];
            }
    }
    
    return $return;
}
        
?>