<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}
include_spip('inc/presentation');
include_spip('inc/config');
include_spip('inc/ciwidget_inc_style');
include_spip('inc/ciwidget_verifier');
include_spip('inc/widget_commun');

function formulaires_ciwidget_configurer_citation_charger_dist() {
    $widget = 'citation';
    return formulaires_ciwidget_configurer_charger($widget);
}

function formulaires_ciwidget_configurer_citation_verifier_dist() {
    $widget = 'citation';
    return formulaires_ciwidget_configurer_verifier($widget);
}

function formulaires_ciwidget_configurer_citation_traiter_dist() {
    $widget = 'citation';
    $return = formulaires_ciwidget_configurer_traiter($widget);
    ciwidget_purger_cache_css();
    return $return;
}

function ciwidget_choix_quote($nom_element='',$valeur_element='',$disabled=''){
    $return = '';
    $selected = '';
    
    if ($disabled){
        $disabled = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('aucun','quote1','quote2','quote3');
    // Parcours du tableau
    $return .= '<select name="'.$nom_element.'" '.$disabled.'>'."\n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_element){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. _T('ciwidget:'.$valeur) .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

?>