<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_tmp');
include_spip('inc/ciwidget_graphique');

function formulaires_ciwidget_graphique2_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
	if (!$id_widget_tmp){
		return false;
        }

        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'graphique');
        
        // securite
	if (!isset($valeurs['objet']) OR !isset($valeurs['id_objet']) OR !isset($valeurs['id_auteur']) 
                OR !autoriser('modifier',$valeurs['objet'],$valeurs['id_objet'])
                OR $valeurs['id_auteur']!=$GLOBALS['visiteur_session']['id_auteur']){
		return false;
        }
        
        $champs_prerequis = array(
            'type'
            );
        foreach ($champs_prerequis AS $champ){
            if (!isset($valeurs[$champ]) OR !$valeurs[$champ]){
                return false;
            }
        }
        
        $valeurs['retour_objet'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp,$objet,$id_objet,$valeurs);
        $valeurs['ci_action'] = self('&', true);
        
	return $valeurs;
}

function formulaires_ciwidget_graphique2_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        $erreurs = array();
        
	$titre = _request('titre');	
	if (!$titre){
            $suivant = _request('suivant');
            if ($suivant){
		$erreurs['titre'] = _T('info_obligatoire');
            }
        } elseif (!ciwidget_verifier_caracteres_speciaux_texte($titre)){
            $erreurs['titre'] = _T('ciwidget:caracteres_autorises');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_graphique2_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        refuser_traiter_formulaire_ajax();    
    
        $type_widget = 'graphique';
        $c = array();
	$c['titre'] = _request('titre');
	$c['descriptif'] = _request('descriptif');
        
        $contenu_nouveau = array();
	$contenu_nouveau['credits'] = _request('credits');

        $id_widget_tmp = ciwidget_maj_tmp($id_widget,$id_widget_tmp,$c,$contenu_nouveau);

        $res = ciwidget_retour_formulaire_etape($objet,$id_objet,$id_widget,$id_widget_tmp,$type_widget,ciwidget_numform());

	return $res;
}

?>