<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');

function formulaires_ciwidget_portrait_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $valeurs = array(
            'titre'=>'',
            'descriptif'=>'', 
            'surtitre'=>'', 
            'fonction'=>'', 
            'organisation_nom'=>'', 
            'organisation_siteweb'=>'', 
            'credit_photo'=>'' 
            );
        
        $id_widget = intval($id_widget);
      	if ($id_widget>0) {
            		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
            		while ($row = sql_fetch($result)) { 
            			$valeurs = $row;
            		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='portrait'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
	       }
        
        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

        if (ciwidget_utiliser_bigup()) {
          $valeurs['_bigup_rechercher_fichiers'] = true;
        }
        
        return $valeurs;
}

function formulaires_ciwidget_portrait_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();

      	$titre = _request('titre');	
      	if (!$titre){
      		$erreurs['titre'] = _T('info_obligatoire');
        }

      	$descriptif = _request('descriptif');	
      	if (!$descriptif){
      		$erreurs['descriptif'] = _T('info_obligatoire');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_portrait_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);

        $c = array();
        $c['titre'] = _request('titre');
	      $c['descriptif'] = _request('descriptif');

        $valeurs = array(
            'surtitre'=>'', 
            'fonction'=>'', 
            'organisation_nom'=>'', 
            'organisation_siteweb'=>'', 
            'credit_photo'=>'' 
           );
       
        $contenu = array();
      	foreach ($valeurs as $champ=>$valeur){
      		$contenu[$champ] = _request($champ);
        }
        
        $c['contenu'] = serialize($contenu);
        
        $type_widget = 'portrait';
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

      	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter
            $id_widget = sql_insertq('spip_ciwidget', $c);

            if ($id_widget){
                // pour associer la vignette
                // (passer de l'identifiant temporaire à celui du widget)
                if (sql_countsel("spip_documents_liens", "objet='ciwidget' AND id_objet=".(0 - intval($GLOBALS['visiteur_session']['id_auteur'])))>0){
                    sql_updateq("spip_documents_liens", array('id_objet'=> $id_widget),"objet='ciwidget' AND id_objet=".(0 - intval($GLOBALS['visiteur_session']['id_auteur'])));
                }
            }
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

?>