<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

function ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,$type_widget){
        $id_widget = intval($id_widget);
        $id_widget_tmp = intval($id_widget_tmp);
        $valeurs=array();
        
        if ($id_widget_tmp>0){
                // mode creation du widget
                // utiliser les donnees temporaires
                $valeurs = ciwidget_valeurs_lues_dans_tmp($id_widget_tmp,$type_widget);
        } elseif ($id_widget>0) {
                // mode modification du widget
                // verser les donnees dans les donnees temporaires
                $id_widget_tmp = ciwidget_verser_widget_dans_tmp($id_widget,$type_widget);
                $valeurs = ciwidget_valeurs_lues_dans_tmp($id_widget_tmp,$type_widget);
	} else {
                // mode creation du widget (premier affichage du formulaire)
                // mettre une valeur par defaut au type de widget (fait dans l'appel de la fonction)
        }
        
        return $valeurs;
}

function ciwidget_valeurs_lues_dans_tmp($id_widget_tmp,$type_widget){
        $valeurs = array();
        
        $id_widget_tmp = intval($id_widget_tmp);
        if ($id_widget_tmp>0){
                // mode creation de graphique
                // utiliser les donnees temporaires
		$result = sql_select("*", "spip_ciwidget_tmp", "id_widget_tmp=$id_widget_tmp");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['id_auteur']) AND $valeurs['id_auteur']!=$GLOBALS['visiteur_session']['id_auteur']){
                    return array();
                }
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!=$type_widget){
                    return array();
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    
                    // important
                    if (isset($contenu['id_widget'])){
                        unset($contenu['id_widget']);
                    }
                    if (isset($contenu['id_widget_tmp'])){
                        unset($contenu['id_widget_tmp']);
                    }
                    
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
        }
        
        return $valeurs;
}

function ciwidget_maj_tmp($id_widget,$id_widget_tmp,$c=array(),$contenu_nouveau=array()){
        $id_widget = intval($id_widget);
        $id_widget_tmp = intval($id_widget_tmp);
        $id_auteur = intval($GLOBALS['visiteur_session']['id_auteur']);
        $contenu_actuel = array();
    
        // important
        if (isset($contenu_nouveau['id_widget'])){
            unset($contenu_nouveau['id_widget']);
        }
        if (isset($contenu_nouveau['id_widget_tmp'])){
            unset($contenu_nouveau['id_widget_tmp']);
        }
        
        if ($id_widget>0 AND !$id_widget_tmp) {
                // mode modification de graphique
                // verifier si les donnees temporaires existent deja
                $result = sql_select("id_widget_tmp", "spip_ciwidget_tmp", "id_widget=".$id_widget." AND id_auteur=".$id_auteur);
                while ($row = sql_fetch($result)) { 
                        $id_widget_tmp = $row['id_widget_tmp'];
                }
        }
        
        if ($id_widget_tmp>0){
                // utiliser les donnees temporaires
                $contenu_actuel = ciwidget_contenu_unserialize_tmp($id_widget_tmp);
                if ($contenu_nouveau AND is_array($contenu_nouveau)){
                    $c['contenu'] = serialize(array_merge($contenu_actuel,$contenu_nouveau));
                } else {
                    $c['contenu'] = serialize($contenu_actuel);
                }
                
                sql_updateq("spip_ciwidget_tmp", $c, "id_widget_tmp=$id_widget_tmp");

	} else {
                // mode creation de graphique (premier affichage du formulaire)
                // ajouter
                $c['contenu'] = serialize($contenu_nouveau);
                
                // compatibilite avec le plugin CISF
                $options = array();
                $self = self();
                if (strpos($self,'page=cisf_')>0) {
                    $options['cisf'] = 'oui';
                }
                // rechercher la rubrique (de maniere securisee)
                $tableau_retour = explode('&',str_replace('&amp;','&',$self));
                foreach ($tableau_retour AS $param){
                    if (substr($param,0,12)=='id_rubrique='){
                        $id_rubrique = intval(substr($param,12));
                        if ($id_rubrique){
                            $options['rubrique'] = $id_rubrique;
                        }
                        break;
                    }
                }
                $c['options'] = serialize($options);
                
                $id_widget_tmp = sql_insertq('spip_ciwidget_tmp', $c);
                // memorise la date de creation du tmp
                ciwidget_maj_date_creation_tmp($id_widget_tmp);
        }
        
        // purger les donnes temporaires qui datent de plus de 24h
        sql_delete("spip_ciwidget_tmp", "maj_tmp < " . sql_quote(date('Y-m-d H:i:s', time() - 24 * 3600)));
        
        return $id_widget_tmp;
}

function ciwidget_contenu_unserialize_tmp($id_widget_tmp){
        $return = array();
        
        $id_widget_tmp = intval($id_widget_tmp);
        if ($id_widget_tmp>0){
		$result = sql_select("contenu", "spip_ciwidget_tmp", "id_widget_tmp=$id_widget_tmp");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
                
                if (isset($valeurs['contenu'])){
                    $return = unserialize($valeurs['contenu']); 
                }
                
                // important
                if (isset($return['id_widget']) ){
                    unset($return['id_widget']);
                }
                if (isset($return['id_widget_tmp'])){
                    unset($return['id_widget_tmp']);
                }
        }
        
        return $return;
}

function ciwidget_contenu_tmp_valeur($id_widget_tmp,$item){
    static $tableau_contenu = array();
    
    if (!$tableau_contenu){
        $tableau_contenu = ciwidget_contenu_unserialize_tmp($id_widget_tmp);
    }
    
    if ($item AND isset($tableau_contenu[$item])){
        return $tableau_contenu[$item];
    } else {
        return '';
    }
}

function ciwidget_verser_widget_dans_tmp($id_widget,$type_widget){
        $id_widget = intval($id_widget);
        $id_auteur = intval($GLOBALS['visiteur_session']['id_auteur']);
        $id_widget_tmp = '';
        $id_widget_tmp_existant = '';
        
        if ($id_widget>0){
            // verifier si les donnees temporaires existent deja pour ce widget et cet auteur
            $result = sql_select("*", "spip_ciwidget_tmp", "id_widget=".$id_widget." AND id_auteur=".$id_auteur,"","date_creation_tmp");
            while ($row = sql_fetch($result)) { 
                    $id_widget_tmp_existant = $row['id_widget_tmp'];
            }

            $result = sql_select("id_widget,type_widget,objet,id_objet,titre,descriptif,contenu,donnees,vu,rang_lien,maj", "spip_ciwidget", "id_widget=$id_widget");
            while ($row = sql_fetch($result)) { 
                    $valeurs = $row;
            }

            // anti hack
            if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!=$type_widget){
                return $id_widget_tmp;
            }

            $valeurs['id_widget'] = $id_widget;
            $valeurs['id_auteur'] = $id_auteur;
            
            // compatibilite avec le plugin CISF
            $options = array();
            $self = self();
            if (strpos($self,'page=cisf_')>0) {
                $options['cisf'] = 'oui';
            }
            // rechercher la rubrique (de maniere securisee)
            $tableau_retour = explode('&',str_replace('&amp;','&',$self));
            foreach ($tableau_retour AS $param){
                if (substr($param,0,12)=='id_rubrique='){
                    $id_rubrique = intval(substr($param,12));
                    if ($id_rubrique){
                        $options['rubrique'] = $id_rubrique;
                    }
                    break;
                }
            }
            $valeurs['options'] = serialize($options);

            // si les donnees temporaires existent deja pour ce widget et cet auteur, les reinitialiser
            if (intval($id_widget_tmp_existant)>0){
                // sauf si F5
                if (isset($_SERVER['HTTP_REFERER'])){
                    sql_updateq("spip_ciwidget_tmp", $valeurs, "id_widget_tmp=".intval($id_widget_tmp_existant));
                }
                $id_widget_tmp = $id_widget_tmp_existant;
            } else {
                $id_widget_tmp = sql_insertq("spip_ciwidget_tmp", $valeurs);
            }
            
            // memorise la date de creation du tmp
            ciwidget_maj_date_creation_tmp($id_widget_tmp);

            // purger les donnes temporaires qui datent de plus de 24h (tous auteurs confondus)
            sql_delete("spip_ciwidget_tmp", "maj_tmp < " . sql_quote(date('Y-m-d H:i:s', time() - 24 * 3600)));
        }
        
        return $id_widget_tmp;
}

function ciwidget_verser_tmp_dans_widget($id_widget_tmp,$type_widget,$id_widget=0){
        $id_widget = intval($id_widget);
        $id_widget_tmp = intval($id_widget_tmp);
        $id_auteur = intval($GLOBALS['visiteur_session']['id_auteur']);
        $valeurs = array();
        
        if ($id_widget_tmp>0){
            // verifier si les donnees permanentes existent deja
            $result = sql_select("*", "spip_ciwidget_tmp", "id_widget_tmp=".$id_widget_tmp);
            while ($row = sql_fetch($result)) { 
                    $valeurs = $row;
                    $id_widget = $row['id_widget'];
                    
                    // enlever certains champs
                    unset($valeurs['id_widget']);
                    unset($valeurs['maj']);
                    unset($valeurs['date_creation_tmp']);
                    unset($valeurs['id_widget_tmp']);
                    unset($valeurs['maj_tmp']);
                    unset($valeurs['options']);
                    unset($valeurs['id_auteur']);
            }

            if (!$id_widget){
                // mode creation de widget

                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!=$type_widget){
                    return $id_widget;
                }

                if ($valeurs){
                    $id_widget = sql_insertq("spip_ciwidget", $valeurs);
                    sql_delete("spip_ciwidget_tmp", "id_widget_tmp=".$id_widget_tmp);
                    
                    if (defined('_DIR_PLUGIN_CITRACE')){
                        if ($citrace = charger_fonction('citrace', 'inc')) {
                            $message = '('.$valeurs['titre'].') dans '.$valeurs['objet'].' '.$valeurs['id_objet'];				
                            $citrace('widget', $id_widget, 'creation du widget de type '.$valeurs['type_widget'], $message);
                        }
                    }

                    // purger les donnes temporaires qui datent de plus de 24h
                    sql_delete("spip_ciwidget_tmp", "maj_tmp < " . sql_quote(date('Y-m-d H:i:s', time() - 24 * 3600)));
                }
            } else {
                if ($valeurs){
                    sql_updateq("spip_ciwidget", $valeurs, "id_widget=$id_widget");
                    
                    if (defined('_DIR_PLUGIN_CITRACE')){
                        if ($citrace = charger_fonction('citrace', 'inc')) {
                            $message = '('.$valeurs['titre'].') dans '.$valeurs['objet'].' '.$valeurs['id_objet'];				
                            $citrace('widget', $id_widget, 'modification du widget de type '.$valeurs['type_widget'], $message);
                        }
                    }
                    
                }
            }    
            
            // purger les donnes temporaires qui datent de plus de 24h
            sql_delete("spip_ciwidget_tmp", "maj_tmp < " . sql_quote(date('Y-m-d H:i:s', time() - 24 * 3600)));
        }
        
        return $id_widget;
}

// verifier si le contenu du tmp a ete modifie depuis sa creation
function ciwidget_tmp_modifie($id_widget_tmp){
    $modification = true;

    if (intval($id_widget_tmp)>0){
        $result = sql_select("maj_tmp,date_creation_tmp", "spip_ciwidget_tmp", "id_widget_tmp=".intval($id_widget_tmp));
        while ($row = sql_fetch($result)) { 
            if ($row['maj_tmp']==$row['date_creation_tmp']){
                $modification = false;
            }
        }
    } else {
        $modification = false;
    }

    return $modification;
}

// memorise la date de creation du tmp
function ciwidget_maj_date_creation_tmp($id_widget_tmp){
    $id_widget_tmp = intval($id_widget_tmp);

    if ($id_widget_tmp>0){
        $maj_tmp = '';
        $result = sql_select("maj_tmp", "spip_ciwidget_tmp", "id_widget_tmp=$id_widget_tmp");
        while ($row = sql_fetch($result)) { 
                $maj_tmp = $row['maj_tmp'];
        }
        if ($maj_tmp){
            sql_updateq("spip_ciwidget_tmp", array('date_creation_tmp'=>$maj_tmp), "id_widget_tmp=$id_widget_tmp");
        }
    }
}

function ciwidget_retour_tmp_vers_objet($id_widget_tmp='',$objet='',$id_objet='',$valeurs=array()){
    $return = '';
    $self = self();
    $options = array();
    $id_widget_tmp = intval($id_widget_tmp);
    
    if ($id_widget_tmp>0){
        $result = sql_select("objet,id_objet,options", "spip_ciwidget_tmp", "id_widget_tmp=$id_widget_tmp");
        while ($row = sql_fetch($result)) { 
                $objet = $row['objet'];
                $id_objet = $row['id_objet'];
                if ($row['options']){
                    $options = unserialize($row['options']);
                }
        }

        if ($objet AND $id_objet){
            include_spip('inc/urls');
            if (isset($options['cisf']) AND $options['cisf']=='oui') {
                $param = 'id_article='.$id_objet;
                // ajouter la rubrique le cas echeant
                if (isset($options['rubrique']) AND intval($options['rubrique'])>0){
                    $param .= "&id_rubrique=".intval($options['rubrique']);
                }
                // compatibilite avec le plugin CISF
                $return = generer_url_public('cisf_article', $param);

            } elseif (test_espace_prive()){
                $return = generer_url_ecrire_objet($objet, $id_objet, '', '', false);
            } else {
                $return = generer_url_ecrire_objet($objet, $id_objet, '', '', true);
            }

            $return = html_entity_decode($return);
        }
        
    } elseif ($objet AND $id_objet){
        include_spip('inc/widget_commun');
        $return = ciwidget_retour_vers_objet($objet, $id_objet);
    } elseif (isset($valeurs['objet']) AND isset($valeurs['id_objet'])) {
        include_spip('inc/widget_commun');
        $return = ciwidget_retour_vers_objet($valeurs['objet'],$valeurs['id_objet']);
    }
    
    return $return;
}

?>