<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/ciwidget_inc_meta');

function ci_dailymotion_fichier($url){
    $return = '';
    $ok = false;
    if (empty($url)){
        return '';
    }

    // verifier l'URL
    if (substr($url, 0, 34)=='https://www.dailymotion.com/video/') {
        $url = substr($url, 34);
        $ok = true;
    } elseif (substr($url, 0, 15)=='https://dai.ly/') {
        $url = substr($url, 15);
        $ok = true;
    } elseif (substr($url, 0, 36)=='https://www.dailymotion.com/partner/') {
	$lastpos = strrpos($url,'/');
	$url = substr($url,$lastpos+1);
        $ok = true;
    } elseif (substr($url, 0, 7)=='dai.ly/') {
        $url = substr($url, 7);
        $ok = true;
    }  

    if ($ok){
        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-');
        $tscs = str_replace($tableau,'',$url);
        if (ctype_alnum($tscs)) {
          $return = $url;
        }
    }
    
    return $return;
}


function ci_deduction_titre($fichier){
  $return = '';
  
  if ($fichier){
        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-');
        $tscs = str_replace($tableau,'',$fichier);
        if (ctype_alnum($tscs)) {
            $return = str_replace($tableau,' ',substr($fichier,8));
  	}
  }
  
  return $return;
}


function ci_youtube_fichier($url){
    $return = '';
    if (empty($url)){
        return '';
    }

    // verifier l'URL
    if (substr($url, 0, 32)=='https://www.youtube.com/watch?v=') {
        $url = substr($url, 32);

        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-');
        $tscs = str_replace($tableau,'',$url);
        if (ctype_alnum($tscs)) {
          $return = $url;
        }
    }  
  
    return $return;
}


function ci_streamhls_url($url){
    $return = '';
    if (empty($url)){
        return '';
    }
    $tscs = trim($url);

    // verifier l'URL
    if (strtolower(substr($tscs, -5))=='.m3u8') {
        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-','.',':','/','?','=');
        $tscs = str_replace($tableau,'',$tscs);
        if (ctype_alnum($tscs)) {
          $return = $url;
        }
    }  
  
  return $return;
}

function ci_streamhls_url_vignette($url){
    $return = '';
    if (empty($url)){
        return '';
    }
    $tscs = trim($url);

    // verifier l'URL
    if (in_array(strtolower(substr($tscs, -4)),array('.jpg','jpeg','.png','.gif'))) {
        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores, tirets
        $tableau = array("_",'-','.',':','/','?','=');
        $tscs = str_replace($tableau,'',$tscs);
        if (ctype_alnum($tscs)) {
          $return = $url;
        }
    }  
  
  return $return;
}


function ciwidget_video_script($arg='', $num_skin=0, $streaming=''){
    static $done = false;
    static $firstarg = 0;
    $return = '';
    $cilang = 'fr';
    if (in_array($GLOBALS['spip_lang'],array('en','es','de')))
            $cilang = $GLOBALS['spip_lang'];
    
    $concat = "lib/videojs/video_concat_v2_".$cilang.".min.js";
    if ($streaming=='hls')
        $concat = "lib/videojs/hls_concat_".$cilang.".min.js";
    elseif ($streaming=='dash')
        $concat = "lib/videojs/dash_concat_".$cilang.".min.js";
    
    $videojspath = find_in_path($concat);
    $videojsswf = find_in_path("lib/videojs/video-js.swf");
    $videojscss = find_in_path("lib/videojs/video-js.min.css"); 
    $videojsskin = ciwidget_chemin_video_skin($num_skin);

    if (!$done OR $firstarg==$arg){
        $done = true;
        $firstarg = $arg;
        $return = '<script>
<!--
var videojspath="'.$videojspath.'",
        videojsswf="'.$videojsswf.'",
        videojscss="'.$videojscss.'", 
        videojsskin="'.$videojsskin.'";

var videojsloader;
(function(){
	var L=videojsloader;
	if (typeof L == "undefined"){ videojsloader = L = {gs:null,css:{},cssload:null}; }    
        L.cssload = function (f){
                if (typeof L.css[f]=="undefined"){
                        L.css[f] = true;
                        var stylesheet = document.createElement("link");
                        stylesheet.href = f;
                        stylesheet.rel = "stylesheet";
                        stylesheet.type = "text/css";
                        document.getElementsByTagName("head")[0].appendChild(stylesheet);
                }
        }

	if (!L.gs || window.location.href.indexOf("/ecrire/") != -1){
		if (typeof videojscss !== "undefined"){	L.cssload(videojscss); }
		if (typeof videojsskin !== "undefined"){ L.cssload(videojsskin); }
                jQuery.ajaxSetup({ cache: true });
                if (typeof videojspath !== "undefined"){	
                    L.gs = jQuery.getScript(videojspath,function(){
                            L.gs = true;
                            if (typeof videojsswf !== "undefined"){ videojs.options.flash.swf = videojsswf; }
                            
                            var ciListeVideo, ciVideoId, ciAtt, ciListeAudio;
                            ciListeVideo = document.getElementsByTagName("video");
                            for(var i = 0, max = ciListeVideo.length; i < max; i++){

// document.createAttribute will be deprecated in DOM4
//                                ciAtt = document.createAttribute("controls");
//                                ciListeVideo[i].setAttributeNode(ciAtt);
                                ciListeVideo[i].setAttribute("controls","");
                                
                                ciVideoId = ciListeVideo[i].id;
                                if (ciVideoId){                                
                                    videojs(ciVideoId).one("play", function(e) {
                                    
                                        var eventLabel, eventSection, parsedOptions;
                                        eventLabel = "";
                                        eventSection = "";
                                        if (this.options_["data-setup"]) {
                                          parsedOptions = JSON.parse(this.options_["data-setup"]);
                                          if (parsedOptions.ciEventPage) {
                                            eventLabel = parsedOptions.ciEventPage;
                                          }
                                          if (parsedOptions.ciEventSection) {
                                            eventSection = parsedOptions.ciEventSection;
                                          }
                                        }
                                        if (typeof ciTrackVideo !== "undefined" && typeof ciTrackVideo === "function"){
                                          ciTrackVideo("C",eventSection,eventLabel,"T");
                                        }
                                        if (typeof ciXitiTrackVideo !== "undefined" && typeof ciXitiTrackVideo === "function"){
                                          ciXitiTrackVideo("C",eventSection,eventLabel,"T");
                                        }
                                        if (typeof ciPiwikTrackVideo !== "undefined" && typeof ciPiwikTrackVideo === "function"){
                                          ciPiwikTrackVideo("C",eventSection,eventLabel,"T");
                                        }
                                    });
                                }
                            }
                            
                            ciListeAudio = document.getElementsByTagName("audio");
                            for(var i = 0, max = ciListeAudio.length; i < max; i++){
// document.createAttribute will be deprecated in DOM4
//                                ciAtt = document.createAttribute("controls");
//                                ciListeAudio[i].setAttributeNode(ciAtt);
                                ciListeAudio[i].setAttribute("controls","");
                            }
                    });
                }
                jQuery.ajaxSetup({ cache: false });
	}
})();
-->
</script>';
    }
    
    return $return;
}

function ciwidget_chemin_video_skin($num_skin=0){
    $skin = "_css/videojs-skin";
    $extension = ".css";
    $numero = "1";
    
    if (intval($num_skin)>0){
        $numero = intval($num_skin);
    } else {
        $numero = ciwidget_lire_meta_cle('commun','video_num_skin');
    }

    // compatibilite ascendante
    if (defined('_CISQUEL_VIDEO_NUM_SKIN')) {
            if (intval(_CISQUEL_VIDEO_NUM_SKIN)>1)
                    $numero = strval(intval(_CISQUEL_VIDEO_NUM_SKIN));
    }	
    
    $chemin = find_in_path($skin.$numero.$extension);
    if (!$chemin)
        $chemin = '';
    
    return $chemin;
}

function ciwidget_video_explication($arg=''){
    $tableau_formats_video_autorises = ciwidget_tableau_formats_video_autorises();
    $formats_video_autorises = implode(', ',$tableau_formats_video_autorises);
    $debit_video_max = ciwidget_lire_meta_cle('commun','debit_video_max');

    $return = '<div>'._T('ciwidget:widget_video_format', array('format_video_autorise'=>$formats_video_autorises)).'</div>';
    
    if (in_array('mp4',$tableau_formats_video_autorises)){
        $return .= '<div>'._T('ciwidget:widget_video_codec_mp4').'</div>';
    }
    
    if ($debit_video_max AND intval($debit_video_max)>0) {
        $return .= '<div>'._T('ciwidget:widget_video_debit_max', array('debit_video_max' => intval($debit_video_max))).'</div>';
    } else {
        $return .= '<div>'._T('ciwidget:widget_video_debit_recommandation').'</div>';
    }
    
    return $return;
}

function ciwidget_tableau_formats_video_autorises(){
    $tableau_complet = array('mp4','webm','ogv');
    $return = $tableau_complet;
    $tableau = array();
    
    foreach ($tableau_complet AS $format){
        if (ciwidget_lire_meta_cle('commun',$format)=='oui'){
            $tableau[] = $format;
        }
    }
    if ($tableau){
        $return = $tableau;
    }

    return $return;
}

function ciwidget_formats_video_autorises($arg=''){
   return implode(',',ciwidget_tableau_formats_video_autorises());
}

function ciwidget_audio_explication($arg=''){
    $tableau_formats_audio_autorises = ciwidget_tableau_formats_audio_autorises();
    $formats_audio_autorises = implode(', ',$tableau_formats_audio_autorises);

    return '<div>'._T('ciwidget:widget_audio_format', array('format_audio_autorise'=>$formats_audio_autorises)).'</div>';
}

function ciwidget_tableau_formats_audio_autorises(){
    return array('mp3','wav','ogg');
}

function ciwidget_formats_audio_autorises($arg=''){
   return implode(',',ciwidget_tableau_formats_audio_autorises());
}

?>